/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     EXT_ASCII_CHAR = 258
   };
#endif
/* Tokens.  */
#define EXT_ASCII_CHAR 258




/* Copy the first part of user declarations.  */
#line 32 "lscp.y"


#include "lscpparser.h"
#include "lscpserver.h"
#include "lscpevent.h"

// to save us typing work in the rules action definitions
#define LSCPSERVER ((yyparse_param_t*) yyparse_param)->pServer
#define SESSION_PARAM ((yyparse_param_t*) yyparse_param)
#define INCREMENT_LINE { SESSION_PARAM->iLine++; SESSION_PARAM->iColumn = 0; }

// clears input buffer
void restart(yyparse_param_t* pparam, int& yychar);
#define RESTART restart((yyparse_param_t*) YYPARSE_PARAM, yychar)

// we provide our own version of yyerror() so we don't have to link against the yacc library
void yyerror(const char* s);

static char buf[1024]; // input buffer to feed the parser with new characters
static int bytes = 0;  // current number of characters in the input buffer
static int ptr   = 0;  // current position in the input buffer
static String sLastError; // error message of the last error occured

// external reference to the function which actually reads from the socket
extern int GetLSCPCommand( void *buf, int max_size);

// external reference to the function in lscpserver.cpp which returns the
// current session (only works because the server runs as singleton)
extern yyparse_param_t* GetCurrentYaccSession();

// returns true if supplied characters has an ASCII code of 128 or higher
inline bool isExtendedAsciiChar(const char c) {
    return (c < 0);
}

// custom scanner function which reads from the socket
// (bison expects it to return the numerical ID of the next
// "recognized token" from the input stream)
int yylex(YYSTYPE* yylval) {
    // check if we have to read new characters
    if (ptr >= bytes) {
        bytes = GetLSCPCommand(buf, 1023);
        ptr   = 0;
        if (bytes < 0) {
            bytes = 0;
            return 0;
        }
    }
    // this is the next character in the input stream
    const char c = buf[ptr++];
    // increment current reading position (just for verbosity / messages)
    GetCurrentYaccSession()->iColumn++;
    // we have to handle "normal" and "extended" ASCII characters separately
    if (isExtendedAsciiChar(c)) {
        // workaround for characters with ASCII code higher than 127
        yylval->Char = c;
        return EXT_ASCII_CHAR;
    } else {
        // simply return the ASCII code as terminal symbol ID
        return (int) c;
    }
}

// parser helper functions

int octalsToNumber(char oct_digit0, char oct_digit1 = '0', char oct_digit2 = '0') {
    const char d0[] = { oct_digit0, '\0' };
    const char d1[] = { oct_digit1, '\0' };
    const char d2[] = { oct_digit2, '\0' };
    return atoi(d2)*8*8 + atoi(d1)*8 + atoi(d0);
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 186 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  57
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4374

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  100
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  184
/* YYNRULES -- Number of rules.  */
#define YYNRULES  557
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2059

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   258

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      98,     2,     2,    99,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    97,    76,    33,     4,    77,    78,    79,    32,
      80,    81,    82,     8,     6,     9,     7,    34,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    83,    84,
      85,     5,    86,    87,    88,    26,    27,    28,    29,    30,
      31,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    89,    35,    90,    91,    92,     2,    20,    21,    22,
      23,    24,    25,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    93,    94,    95,    96,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,    10,    11,    13,    15,    17,    19,
      22,    25,    28,    31,    35,    39,    43,    47,    51,    55,
      59,    63,    67,    71,    75,    79,    83,    87,    91,    95,
      99,   103,   107,   109,   111,   113,   117,   127,   135,   143,
     153,   159,   167,   169,   173,   175,   177,   179,   181,   183,
     185,   187,   189,   191,   193,   195,   197,   199,   201,   203,
     205,   207,   209,   211,   213,   215,   217,   219,   221,   223,
     225,   227,   229,   231,   233,   235,   237,   239,   241,   243,
     245,   247,   249,   251,   253,   255,   257,   259,   261,   263,
     265,   282,   301,   320,   341,   349,   353,   357,   361,   367,
     371,   375,   377,   379,   385,   393,   403,   405,   411,   419,
     429,   431,   433,   439,   445,   453,   463,   471,   481,   483,
     489,   497,   503,   509,   515,   519,   521,   523,   527,   531,
     541,   543,   549,   553,   561,   567,   571,   577,   583,   587,
     593,   599,   601,   609,   619,   627,   637,   647,   651,   659,
     669,   681,   691,   701,   709,   717,   725,   733,   737,   741,
     747,   751,   757,   761,   767,   775,   779,   783,   787,   795,
     801,   809,   815,   821,   827,   833,   839,   843,   847,   853,
     857,   861,   867,   875,   881,   891,   897,   903,   909,   915,
     921,   927,   933,   939,   945,   951,   957,   959,   960,   963,
     967,   973,   975,   977,   979,   981,   983,   985,   987,   989,
     993,   997,   999,  1003,  1009,  1013,  1019,  1023,  1029,  1037,
    1041,  1043,  1045,  1047,  1049,  1051,  1053,  1055,  1057,  1059,
    1061,  1063,  1065,  1067,  1069,  1071,  1073,  1075,  1077,  1079,
    1081,  1083,  1085,  1087,  1089,  1091,  1093,  1097,  1099,  1101,
    1103,  1105,  1109,  1115,  1117,  1119,  1121,  1123,  1125,  1127,
    1129,  1133,  1138,  1143,  1145,  1148,  1150,  1152,  1154,  1156,
    1158,  1160,  1162,  1164,  1166,  1168,  1170,  1172,  1174,  1176,
    1178,  1180,  1182,  1184,  1186,  1188,  1190,  1192,  1194,  1196,
    1198,  1200,  1202,  1204,  1206,  1208,  1210,  1212,  1214,  1216,
    1218,  1220,  1222,  1224,  1226,  1228,  1230,  1233,  1236,  1239,
    1242,  1245,  1248,  1251,  1254,  1257,  1261,  1265,  1267,  1270,
    1273,  1277,  1281,  1285,  1289,  1291,  1293,  1296,  1299,  1301,
    1303,  1306,  1309,  1311,  1313,  1316,  1319,  1321,  1324,  1326,
    1328,  1331,  1334,  1336,  1338,  1340,  1342,  1344,  1346,  1348,
    1350,  1352,  1354,  1356,  1358,  1360,  1362,  1364,  1366,  1368,
    1370,  1372,  1374,  1376,  1378,  1380,  1382,  1384,  1386,  1388,
    1390,  1392,  1394,  1396,  1398,  1400,  1402,  1404,  1406,  1408,
    1410,  1412,  1414,  1416,  1418,  1420,  1422,  1424,  1426,  1428,
    1430,  1432,  1434,  1436,  1438,  1440,  1442,  1444,  1446,  1448,
    1450,  1452,  1454,  1456,  1458,  1460,  1462,  1464,  1466,  1468,
    1470,  1472,  1474,  1476,  1478,  1480,  1482,  1484,  1486,  1488,
    1490,  1492,  1494,  1496,  1498,  1500,  1502,  1504,  1506,  1508,
    1510,  1512,  1514,  1516,  1518,  1520,  1523,  1526,  1529,  1532,
    1535,  1538,  1541,  1544,  1547,  1549,  1551,  1554,  1558,  1563,
    1567,  1572,  1574,  1576,  1578,  1582,  1586,  1590,  1596,  1602,
    1607,  1612,  1617,  1624,  1632,  1637,  1642,  1646,  1651,  1659,
    1669,  1676,  1680,  1690,  1702,  1710,  1728,  1759,  1768,  1773,
    1799,  1824,  1848,  1871,  1897,  1922,  1944,  1965,  1995,  2024,
    2044,  2063,  2087,  2101,  2114,  2128,  2141,  2153,  2166,  2178,
    2196,  2218,  2230,  2241,  2248,  2258,  2273,  2284,  2314,  2335,
    2355,  2385,  2405,  2436,  2457,  2475,  2504,  2532,  2558,  2577,
    2595,  2623,  2639,  2656,  2676,  2697,  2715,  2731,  2750,  2766,
    2777,  2793,  2801,  2810,  2834,  2860,  2875,  2889,  2908,  2923,
    2935,  2941,  2946,  2956,  2970,  2977,  2984,  2990,  2995,  3000,
    3006,  3017,  3022,  3029,  3035,  3049,  3054,  3059
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     101,     0,    -1,   102,   178,    -1,   102,   179,   178,    -1,
      -1,   103,    -1,   104,    -1,     1,    -1,     4,    -1,   103,
       4,    -1,   103,   177,    -1,   103,   162,    -1,   103,   170,
      -1,   180,   177,   105,    -1,   182,   177,   108,    -1,   183,
     177,   109,    -1,   181,   177,   111,    -1,   188,   177,   113,
      -1,   189,   177,   119,    -1,   190,   177,   127,    -1,   191,
     177,   120,    -1,   196,   177,   110,    -1,   197,   177,   112,
      -1,   198,   177,   106,    -1,   199,   177,   107,    -1,   279,
     177,   114,    -1,   184,   177,   115,    -1,   185,   177,   116,
      -1,   186,   177,   117,    -1,   187,   177,   118,    -1,   277,
     177,   122,    -1,   278,   177,   123,    -1,   279,    -1,   283,
      -1,   200,    -1,   259,   177,   147,    -1,   261,   177,   195,
     177,   155,   177,   147,   177,   146,    -1,   261,   177,   155,
     177,   147,   177,   146,    -1,   261,   177,   195,   177,   147,
     177,   146,    -1,   261,   177,   195,   177,   147,   177,   146,
     177,   143,    -1,   261,   177,   147,   177,   146,    -1,   261,
     177,   147,   177,   146,   177,   143,    -1,   249,    -1,   249,
     177,   148,    -1,   205,    -1,   206,    -1,   207,    -1,   208,
      -1,   218,    -1,   224,    -1,   223,    -1,   222,    -1,   219,
      -1,   220,    -1,   221,    -1,   209,    -1,   210,    -1,   211,
      -1,   212,    -1,   213,    -1,   214,    -1,   215,    -1,   216,
      -1,   217,    -1,   280,    -1,   225,    -1,   227,    -1,   205,
      -1,   206,    -1,   207,    -1,   208,    -1,   218,    -1,   224,
      -1,   223,    -1,   222,    -1,   219,    -1,   220,    -1,   221,
      -1,   209,    -1,   210,    -1,   211,    -1,   212,    -1,   213,
      -1,   214,    -1,   215,    -1,   216,    -1,   217,    -1,   280,
      -1,   225,    -1,   227,    -1,   247,   177,   124,   137,   177,
     138,   177,   139,   177,   145,   177,   146,   177,   143,   177,
     141,    -1,   247,   177,   124,   137,   177,   138,   177,   139,
     177,   145,   177,   146,   177,   143,   177,   141,   177,   130,
      -1,   247,   177,   124,   137,   177,   138,   177,   139,   177,
     145,   177,   146,   177,   143,   177,   141,   177,   149,    -1,
     247,   177,   124,   137,   177,   138,   177,   139,   177,   145,
     177,   146,   177,   143,   177,   141,   177,   130,   177,   149,
      -1,   247,   177,   137,   177,   138,   177,   139,    -1,   200,
     177,   142,    -1,   249,   177,   137,    -1,   249,   177,   192,
      -1,   259,   177,   266,   177,   147,    -1,   259,   177,   147,
      -1,   262,   177,   147,    -1,   201,    -1,   241,    -1,   251,
     177,   204,   177,   170,    -1,   246,   177,   204,   177,   170,
     177,   170,    -1,   246,   177,   204,   177,   170,   177,   170,
     177,   125,    -1,   202,    -1,   237,   177,   204,   177,   170,
      -1,   236,   177,   204,   177,   170,   177,   170,    -1,   236,
     177,   204,   177,   170,   177,   170,   177,   125,    -1,   234,
      -1,   244,    -1,   235,   177,   204,   177,   162,    -1,   245,
     177,   204,   177,   162,    -1,   252,   177,   204,   177,   162,
     177,   162,    -1,   243,   177,   204,   177,   162,   177,   162,
     177,   170,    -1,   239,   177,   204,   177,   162,   177,   162,
      -1,   238,   177,   204,   177,   162,   177,   162,   177,   170,
      -1,   203,    -1,   200,   177,   204,   177,   142,    -1,   200,
     177,   222,   177,   126,   177,   142,    -1,   200,   177,   223,
     177,   142,    -1,   200,   177,   224,   177,   142,    -1,   229,
     177,   204,   177,   145,    -1,   270,   177,   204,    -1,   225,
      -1,   226,    -1,   248,   177,   137,    -1,   248,   177,   192,
      -1,   247,   177,   204,   177,   137,   177,   138,   177,   139,
      -1,   250,    -1,   249,   177,   204,   177,   137,    -1,   258,
     177,   142,    -1,   257,   177,   204,   177,   142,   177,   144,
      -1,   260,   177,   268,   177,   147,    -1,   260,   177,   147,
      -1,   259,   177,   204,   177,   147,    -1,   261,   177,   268,
     177,   147,    -1,   261,   177,   147,    -1,   262,   177,   204,
     177,   147,    -1,   263,   177,   204,   177,   162,    -1,   271,
      -1,   233,   177,   162,   177,   170,     5,   151,    -1,   238,
     177,   162,   177,   162,   177,   170,     5,   151,    -1,   242,
     177,   162,   177,   170,     5,   151,    -1,   243,   177,   162,
     177,   162,   177,   170,     5,   193,    -1,   243,   177,   162,
     177,   162,   177,   170,     5,   151,    -1,   200,   177,   121,
      -1,   249,   177,   281,   177,   137,   177,   148,    -1,   257,
     177,   281,   177,   142,   177,   144,   177,   150,    -1,   257,
     177,   239,   177,   142,   177,   144,   177,   132,   177,   132,
      -1,   257,   177,   256,   177,   142,   177,   144,   177,   140,
      -1,   257,   177,   272,   177,   142,   177,   144,   177,   141,
      -1,   259,   177,   281,   177,   147,   177,   166,    -1,   259,
     177,   265,   177,   147,   177,   166,    -1,   262,   177,   281,
     177,   147,   177,   166,    -1,   262,   177,   265,   177,   147,
     177,   166,    -1,   282,   177,   156,    -1,   271,   177,   141,
      -1,   235,   177,   170,   177,   125,    -1,   235,   177,   170,
      -1,   245,   177,   170,   177,   125,    -1,   245,   177,   170,
      -1,   257,   177,   142,   177,   140,    -1,   257,   177,   142,
     177,   140,   177,   150,    -1,   200,   177,   142,    -1,   248,
     177,   137,    -1,   248,   177,   192,    -1,   261,   177,   269,
     177,   147,   177,   153,    -1,   261,   177,   147,   177,   153,
      -1,   260,   177,   269,   177,   147,   177,   153,    -1,   260,
     177,   147,   177,   153,    -1,   259,   177,   147,   177,   147,
      -1,   262,   177,   147,   177,   147,    -1,   259,   177,   147,
     177,   147,    -1,   262,   177,   147,   177,   147,    -1,   235,
     177,   162,    -1,   245,   177,   162,    -1,   257,   177,   142,
     177,   144,    -1,   228,   177,   128,    -1,   229,   177,   129,
      -1,   235,   177,   142,   177,   131,    -1,   239,   177,   142,
     177,   132,   177,   132,    -1,   240,   177,   142,   177,   133,
      -1,   255,   177,   142,   177,   131,   177,   134,   177,   135,
      -1,   245,   177,   142,   177,   131,    -1,   252,   177,   142,
     177,   134,    -1,   253,   177,   142,   177,   135,    -1,   254,
     177,   142,   177,   136,    -1,   271,   177,   142,   177,   141,
      -1,   273,   177,   142,   177,   156,    -1,   274,   177,   142,
     177,   156,    -1,   249,   177,   142,   177,   137,    -1,   249,
     177,   142,   177,   193,    -1,   249,   177,   142,   177,   194,
      -1,   200,   177,   228,   177,   142,    -1,   264,    -1,    -1,
     195,   177,    -1,   170,     5,   151,    -1,   125,   177,   170,
       5,   151,    -1,   275,    -1,   276,    -1,   234,    -1,   244,
      -1,   203,    -1,   201,    -1,   241,    -1,   202,    -1,   248,
     177,   137,    -1,   248,   177,   192,    -1,   250,    -1,   258,
     177,   142,    -1,   260,   177,   268,   177,   147,    -1,   260,
     177,   147,    -1,   261,   177,   268,   177,   147,    -1,   261,
     177,   147,    -1,   146,   177,   143,   177,   142,    -1,   195,
     177,   146,   177,   143,   177,   142,    -1,   145,   177,   142,
      -1,   230,    -1,   231,    -1,   232,    -1,   162,    -1,   162,
      -1,   170,    -1,   162,    -1,   162,    -1,   192,    -1,   170,
      -1,   162,    -1,   162,    -1,   162,    -1,   162,    -1,   157,
      -1,   162,    -1,   162,    -1,   162,    -1,   162,    -1,   170,
      -1,   163,    -1,   163,    -1,   166,    -1,   166,    -1,   166,
      -1,   152,    -1,   151,     6,   152,    -1,   170,    -1,   165,
      -1,   162,    -1,   157,    -1,   170,     5,   154,    -1,   153,
     177,   170,     5,   154,    -1,   169,    -1,   166,    -1,   268,
      -1,   269,    -1,   267,    -1,   162,    -1,   170,    -1,   158,
       7,   158,    -1,     8,   158,     7,   158,    -1,     9,   158,
       7,   158,    -1,   159,    -1,   158,   159,    -1,    10,    -1,
      11,    -1,    12,    -1,    13,    -1,    14,    -1,    15,    -1,
      16,    -1,    17,    -1,    18,    -1,    19,    -1,    10,    -1,
      11,    -1,    12,    -1,    13,    -1,    14,    -1,    15,    -1,
      16,    -1,    17,    -1,    10,    -1,    11,    -1,    12,    -1,
      13,    -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,
      18,    -1,    19,    -1,    20,    -1,    21,    -1,    22,    -1,
      23,    -1,    24,    -1,    25,    -1,    26,    -1,    27,    -1,
      28,    -1,    29,    -1,    30,    -1,    31,    -1,   159,    -1,
      11,   158,    -1,    12,   158,    -1,    13,   158,    -1,    14,
     158,    -1,    15,   158,    -1,    16,   158,    -1,    17,   158,
      -1,    18,   158,    -1,    19,   158,    -1,    32,   164,    32,
      -1,    33,   164,    33,    -1,    34,    -1,   164,    34,    -1,
     164,   168,    -1,    32,   167,    32,    -1,    33,   167,    33,
      -1,    32,   169,    32,    -1,    33,   169,    33,    -1,   177,
      -1,   170,    -1,   167,   177,    -1,   167,   170,    -1,   177,
      -1,   171,    -1,   168,   177,    -1,   168,   171,    -1,    34,
      -1,   168,    -1,   169,    34,    -1,   169,   168,    -1,   172,
      -1,   170,   172,    -1,   173,    -1,   174,    -1,   171,   173,
      -1,   171,   174,    -1,   173,    -1,    35,    -1,    34,    -1,
      26,    -1,    27,    -1,    28,    -1,    29,    -1,    30,    -1,
      31,    -1,    36,    -1,    37,    -1,    38,    -1,    39,    -1,
      40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,    -1,
      45,    -1,    46,    -1,    47,    -1,    48,    -1,    49,    -1,
      50,    -1,    51,    -1,    52,    -1,    53,    -1,    54,    -1,
      55,    -1,    20,    -1,    21,    -1,    22,    -1,    23,    -1,
      24,    -1,    25,    -1,    56,    -1,    57,    -1,    58,    -1,
      59,    -1,    60,    -1,    61,    -1,    62,    -1,    63,    -1,
      64,    -1,    65,    -1,    66,    -1,    67,    -1,    68,    -1,
      69,    -1,    70,    -1,    71,    -1,    72,    -1,    73,    -1,
      74,    -1,    75,    -1,    10,    -1,    11,    -1,    12,    -1,
      13,    -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,
      18,    -1,    19,    -1,    76,    -1,     4,    -1,    77,    -1,
      78,    -1,    79,    -1,    80,    -1,    81,    -1,    82,    -1,
       8,    -1,     9,    -1,     7,    -1,     6,    -1,    83,    -1,
      84,    -1,    85,    -1,     5,    -1,    86,    -1,    87,    -1,
      88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    95,    -1,    96,    -1,     3,    -1,
      35,    32,    -1,    35,    33,    -1,    35,    35,    -1,    35,
      34,    -1,    35,    63,    -1,    35,    67,    -1,    35,    25,
      -1,    35,    69,    -1,    35,    71,    -1,   175,    -1,   176,
      -1,    35,   160,    -1,    35,   160,   160,    -1,    35,   160,
     160,   160,    -1,    35,    73,   161,    -1,    35,    73,   161,
     161,    -1,    97,    -1,    98,    -1,    99,    -1,    26,    29,
      29,    -1,    36,    30,    49,    -1,    42,    26,    45,    -1,
      50,    43,    42,    26,    45,    -1,    28,    41,    30,    26,
      47,    -1,    31,    38,    43,    29,    -1,    42,    44,    51,
      30,    -1,    28,    44,    45,    54,    -1,    28,    47,    30,
      26,    49,    30,    -1,    29,    30,    48,    49,    47,    44,
      54,    -1,    41,    38,    48,    49,    -1,    41,    44,    26,
      29,    -1,    26,    41,    41,    -1,    43,    44,    43,    30,
      -1,    29,    30,    31,    26,    50,    41,    49,    -1,    43,
      44,    43,    92,    42,    44,    29,    26,    41,    -1,    47,
      30,    42,    44,    51,    30,    -1,    48,    30,    49,    -1,
      48,    50,    27,    48,    28,    47,    38,    27,    30,    -1,
      50,    43,    48,    50,    27,    48,    28,    47,    38,    27,
      30,    -1,    28,    37,    26,    43,    43,    30,    41,    -1,
      26,    51,    26,    38,    41,    26,    27,    41,    30,    92,
      30,    43,    36,    38,    43,    30,    48,    -1,    26,    51,
      26,    38,    41,    26,    27,    41,    30,    92,    26,    50,
      29,    38,    44,    92,    44,    50,    49,    45,    50,    49,
      92,    29,    47,    38,    51,    30,    47,    48,    -1,    28,
      37,    26,    43,    43,    30,    41,    48,    -1,    38,    43,
      31,    44,    -1,    26,    50,    29,    38,    44,    92,    44,
      50,    49,    45,    50,    49,    92,    29,    30,    51,    38,
      28,    30,    92,    28,    44,    50,    43,    49,    -1,    26,
      50,    29,    38,    44,    92,    44,    50,    49,    45,    50,
      49,    92,    29,    30,    51,    38,    28,    30,    92,    38,
      43,    31,    44,    -1,    42,    38,    29,    38,    92,    38,
      43,    45,    50,    49,    92,    29,    30,    51,    38,    28,
      30,    92,    28,    44,    50,    43,    49,    -1,    42,    38,
      29,    38,    92,    38,    43,    45,    50,    49,    92,    29,
      30,    51,    38,    28,    30,    92,    38,    43,    31,    44,
      -1,    42,    38,    29,    38,    92,    38,    43,    48,    49,
      47,    50,    42,    30,    43,    49,    92,    42,    26,    45,
      92,    28,    44,    50,    43,    49,    -1,    42,    38,    29,
      38,    92,    38,    43,    48,    49,    47,    50,    42,    30,
      43,    49,    92,    42,    26,    45,    92,    38,    43,    31,
      44,    -1,    42,    38,    29,    38,    92,    38,    43,    48,
      49,    47,    50,    42,    30,    43,    49,    92,    28,    44,
      50,    43,    49,    -1,    42,    38,    29,    38,    92,    38,
      43,    48,    49,    47,    50,    42,    30,    43,    49,    92,
      38,    43,    31,    44,    -1,    29,    27,    92,    38,    43,
      48,    49,    47,    50,    42,    30,    43,    49,    92,    29,
      38,    47,    30,    28,    49,    44,    47,    54,    92,    28,
      44,    50,    43,    49,    -1,    29,    27,    92,    38,    43,
      48,    49,    47,    50,    42,    30,    43,    49,    92,    29,
      38,    47,    30,    28,    49,    44,    47,    54,    92,    38,
      43,    31,    44,    -1,    29,    27,    92,    38,    43,    48,
      49,    47,    50,    42,    30,    43,    49,    92,    28,    44,
      50,    43,    49,    -1,    29,    27,    92,    38,    43,    48,
      49,    47,    50,    42,    30,    43,    49,    92,    38,    43,
      31,    44,    -1,    29,    27,    92,    38,    43,    48,    49,
      47,    50,    42,    30,    43,    49,    48,    92,    39,    44,
      27,    92,    38,    43,    31,    44,    -1,    28,    37,    26,
      43,    43,    30,    41,    92,    28,    44,    50,    43,    49,
      -1,    28,    37,    26,    43,    43,    30,    41,    92,    38,
      43,    31,    44,    -1,    31,    53,    92,    48,    30,    43,
      29,    92,    28,    44,    50,    43,    49,    -1,    31,    53,
      92,    48,    30,    43,    29,    92,    38,    43,    31,    44,
      -1,    27,    50,    31,    31,    30,    47,    92,    31,    38,
      41,    41,    -1,    48,    49,    47,    30,    26,    42,    92,
      28,    44,    50,    43,    49,    -1,    51,    44,    38,    28,
      30,    92,    28,    44,    50,    43,    49,    -1,    49,    44,
      49,    26,    41,    92,    51,    44,    38,    28,    30,    92,
      28,    44,    50,    43,    49,    -1,    49,    44,    49,    26,
      41,    92,    51,    44,    38,    28,    30,    92,    28,    44,
      50,    43,    49,    92,    42,    26,    53,    -1,    36,    41,
      44,    27,    26,    41,    92,    38,    43,    31,    44,    -1,
      38,    43,    48,    49,    47,    50,    42,    30,    43,    49,
      -1,    30,    43,    36,    38,    43,    30,    -1,    44,    43,
      92,    29,    30,    42,    26,    43,    29,    -1,    44,    43,
      92,    29,    30,    42,    26,    43,    29,    92,    37,    44,
      41,    29,    -1,    45,    30,    47,    48,    38,    48,    49,
      30,    43,    49,    -1,    26,    50,    29,    38,    44,    92,
      44,    50,    49,    45,    50,    49,    92,    29,    30,    51,
      38,    28,    30,    92,    45,    26,    47,    26,    42,    30,
      49,    30,    47,    -1,    26,    50,    29,    38,    44,    92,
      44,    50,    49,    45,    50,    49,    92,    29,    30,    51,
      38,    28,    30,    48,    -1,    26,    50,    29,    38,    44,
      92,    44,    50,    49,    45,    50,    49,    92,    29,    30,
      51,    38,    28,    30,    -1,    26,    50,    29,    38,    44,
      92,    44,    50,    49,    45,    50,    49,    92,    29,    47,
      38,    51,    30,    47,    92,    45,    26,    47,    26,    42,
      30,    49,    30,    47,    -1,    26,    50,    29,    38,    44,
      92,    44,    50,    49,    45,    50,    49,    92,    29,    47,
      38,    51,    30,    47,    -1,    26,    50,    29,    38,    44,
      92,    44,    50,    49,    45,    50,    49,    92,    28,    37,
      26,    43,    43,    30,    41,    92,    45,    26,    47,    26,
      42,    30,    49,    30,    47,    -1,    26,    50,    29,    38,
      44,    92,    44,    50,    49,    45,    50,    49,    92,    28,
      37,    26,    43,    43,    30,    41,    -1,    26,    50,    29,
      38,    44,    92,    44,    50,    49,    45,    50,    49,    92,
      49,    54,    45,    30,    -1,    26,    51,    26,    38,    41,
      26,    27,    41,    30,    92,    42,    38,    29,    38,    92,
      38,    43,    45,    50,    49,    92,    29,    47,    38,    51,
      30,    47,    48,    -1,    42,    38,    29,    38,    92,    38,
      43,    45,    50,    49,    92,    29,    30,    51,    38,    28,
      30,    92,    45,    26,    47,    26,    42,    30,    49,    30,
      47,    -1,    42,    38,    29,    38,    92,    38,    43,    45,
      50,    49,    92,    45,    44,    47,    49,    92,    45,    26,
      47,    26,    42,    30,    49,    30,    47,    -1,    42,    38,
      29,    38,    92,    38,    43,    45,    50,    49,    92,    29,
      30,    51,    38,    28,    30,    48,    -1,    42,    38,    29,
      38,    92,    38,    43,    45,    50,    49,    92,    29,    30,
      51,    38,    28,    30,    -1,    42,    38,    29,    38,    92,
      38,    43,    45,    50,    49,    92,    29,    47,    38,    51,
      30,    47,    92,    45,    26,    47,    26,    42,    30,    49,
      30,    47,    -1,    42,    38,    29,    38,    92,    38,    43,
      48,    49,    47,    50,    42,    30,    43,    49,    -1,    42,
      38,    29,    38,    92,    38,    43,    48,    49,    47,    50,
      42,    30,    43,    49,    48,    -1,    42,    38,    29,    38,
      92,    38,    43,    48,    49,    47,    50,    42,    30,    43,
      49,    92,    42,    26,    45,    -1,    42,    38,    29,    38,
      92,    38,    43,    48,    49,    47,    50,    42,    30,    43,
      49,    92,    42,    26,    45,    48,    -1,    42,    38,    29,
      38,    92,    38,    43,    45,    50,    49,    92,    29,    47,
      38,    51,    30,    47,    -1,    42,    38,    29,    38,    92,
      38,    43,    45,    50,    49,    92,    45,    44,    47,    49,
      -1,    42,    38,    29,    38,    92,    38,    43,    45,    50,
      49,    92,    28,    37,    26,    43,    43,    30,    41,    -1,
      42,    38,    29,    38,    92,    38,    43,    45,    50,    49,
      92,    49,    54,    45,    30,    -1,    42,    38,    29,    38,
      92,    38,    43,    45,    50,    49,    -1,    42,    38,    29,
      38,    92,    28,    44,    43,    49,    47,    44,    41,    41,
      30,    47,    -1,    31,    53,    92,    48,    30,    43,    29,
      -1,    31,    53,    92,    48,    30,    43,    29,    48,    -1,
      29,    27,    92,    38,    43,    48,    49,    47,    50,    42,
      30,    43,    49,    92,    29,    38,    47,    30,    28,    49,
      44,    47,    54,    -1,    29,    27,    92,    38,    43,    48,
      49,    47,    50,    42,    30,    43,    49,    92,    29,    38,
      47,    30,    28,    49,    44,    47,    38,    30,    48,    -1,
      29,    27,    92,    38,    43,    48,    49,    47,    50,    42,
      30,    43,    49,    48,    -1,    29,    27,    92,    38,    43,
      48,    49,    47,    50,    42,    30,    43,    49,    -1,    29,
      27,    92,    38,    43,    48,    49,    47,    50,    42,    30,
      43,    49,    48,    92,    39,    44,    27,    -1,    38,    43,
      48,    49,    47,    50,    42,    30,    43,    49,    48,    92,
      29,    27,    -1,    29,    30,    48,    28,    47,    38,    45,
      49,    38,    44,    43,    -1,    31,    44,    47,    28,    30,
      -1,    31,    41,    26,    49,    -1,    47,    30,    28,    50,
      47,    48,    38,    51,    30,    -1,    43,    44,    43,    92,
      47,    30,    28,    50,    47,    48,    38,    51,    30,    -1,
      48,    30,    47,    51,    30,    47,    -1,    51,    44,    41,
      50,    42,    30,    -1,    41,    30,    51,    30,    41,    -1,
      42,    50,    49,    30,    -1,    48,    44,    41,    44,    -1,
      27,    54,    49,    30,    48,    -1,    45,    30,    47,    28,
      30,    43,    49,    26,    36,    30,    -1,    30,    29,    38,
      49,    -1,    31,    44,    47,    42,    26,    49,    -1,    47,
      30,    48,    30,    49,    -1,    42,    38,    48,    28,    30,
      41,    41,    26,    43,    30,    44,    50,    48,    -1,    43,
      26,    42,    30,    -1,    30,    28,    37,    44,    -1,    46,
      50,    38,    49,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   139,   139,   140,   143,   144,   145,   146,   149,   150,
     151,   152,   153,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     241,   242,   243,   244,   247,   250,   251,   252,   253,   254,
     255,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   320,
     321,   322,   323,   324,   325,   328,   331,   332,   335,   336,
     337,   338,   341,   342,   345,   346,   349,   350,   351,   354,
     355,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   374,   377,   380,   381,   384,
     385,   388,   389,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   408,   409,   412,
     415,   416,   417,   420,   423,   426,   429,   432,   433,   436,
     439,   442,   445,   448,   451,   452,   455,   458,   461,   464,
     467,   470,   473,   476,   479,   482,   483,   487,   488,   489,
     490,   493,   494,   497,   498,   501,   502,   503,   511,   512,
     515,   516,   517,   521,   522,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   537,   538,   539,   540,   541,
     542,   543,   544,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   583,   584,   587,   588,   589,
     592,   593,   596,   597,   600,   601,   602,   603,   607,   608,
     609,   610,   613,   614,   615,   616,   619,   620,   623,   624,
     625,   626,   630,   631,   632,   636,   636,   636,   636,   636,
     636,   636,   636,   636,   636,   636,   636,   636,   636,   636,
     636,   636,   636,   636,   636,   636,   636,   636,   636,   636,
     636,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   637,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   640,
     640,   640,   640,   640,   640,   640,   641,   641,   641,   641,
     642,   642,   642,   642,   643,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   659,   660,   661,   664,
     665,   670,   673,   676,   679,   682,   685,   688,   691,   694,
     697,   700,   703,   706,   709,   712,   715,   718,   721,   724,
     727,   730,   733,   736,   739,   742,   745,   748,   751,   754,
     757,   760,   763,   766,   769,   772,   775,   778,   781,   784,
     787,   790,   793,   796,   799,   802,   805,   808,   811,   814,
     817,   820,   823,   826,   829,   832,   835,   838,   841,   844,
     847,   850,   853,   856,   859,   862,   865,   868,   871,   874,
     877,   880,   883,   886,   889,   892,   895,   898,   901,   904,
     907,   910,   913,   916,   919,   922,   925,   928,   931,   934,
     937,   940,   943,   946,   949,   952,   955,   958,   961,   964,
     967,   970,   973,   976,   979,   982,   985,   988
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "EXT_ASCII_CHAR", "'#'", "'='", "','",
  "'.'", "'+'", "'-'", "'0'", "'1'", "'2'", "'3'", "'4'", "'5'", "'6'",
  "'7'", "'8'", "'9'", "'a'", "'b'", "'c'", "'d'", "'e'", "'f'", "'A'",
  "'B'", "'C'", "'D'", "'E'", "'F'", "'''", "'\"'", "'/'", "'\\\\'", "'G'",
  "'H'", "'I'", "'J'", "'K'", "'L'", "'M'", "'N'", "'O'", "'P'", "'Q'",
  "'R'", "'S'", "'T'", "'U'", "'V'", "'W'", "'X'", "'Y'", "'Z'", "'g'",
  "'h'", "'i'", "'j'", "'k'", "'l'", "'m'", "'n'", "'o'", "'p'", "'q'",
  "'r'", "'s'", "'t'", "'u'", "'v'", "'w'", "'x'", "'y'", "'z'", "'!'",
  "'$'", "'%'", "'&'", "'('", "')'", "'*'", "':'", "';'", "'<'", "'>'",
  "'?'", "'@'", "'['", "']'", "'^'", "'_'", "'{'", "'|'", "'}'", "'~'",
  "' '", "'\\n'", "'\\r'", "$accept", "input", "line", "comment",
  "command", "add_instruction", "subscribe_event", "unsubscribe_event",
  "map_instruction", "unmap_instruction", "remove_instruction",
  "get_instruction", "set_instruction", "create_instruction",
  "reset_instruction", "clear_instruction", "find_instruction",
  "move_instruction", "copy_instruction", "destroy_instruction",
  "load_instruction", "set_chan_instruction", "edit_instruction",
  "format_instruction", "modal_arg", "key_val_list", "buffer_size_type",
  "list_instruction", "load_instr_args", "load_engine_args",
  "instr_load_mode", "device_index", "audio_channel_index",
  "audio_output_type_name", "midi_input_port_index",
  "midi_input_channel_index", "midi_input_type_name", "midi_map",
  "midi_bank", "midi_prog", "midi_ctrl", "volume_value", "sampler_channel",
  "instrument_index", "fx_send_id", "engine_name", "filename", "db_path",
  "map_name", "entry_name", "fx_send_name", "param_val_list", "param_val",
  "query_val_list", "query_val", "scan_mode", "boolean", "dotnum",
  "digits", "digit", "digit_oct", "digit_hex", "number", "path",
  "path_base", "stringval", "stringval_escaped", "text",
  "text_escaped_base", "text_escaped", "string", "string_escaped", "char",
  "char_base", "escape_seq", "escape_seq_octal", "escape_seq_hex", "SP",
  "LF", "CR", "ADD", "GET", "MAP", "UNMAP", "CLEAR", "FIND", "MOVE",
  "COPY", "CREATE", "DESTROY", "LIST", "LOAD", "ALL", "NONE", "DEFAULT",
  "NON_MODAL", "REMOVE", "SET", "SUBSCRIBE", "UNSUBSCRIBE", "CHANNEL",
  "AVAILABLE_ENGINES", "AVAILABLE_AUDIO_OUTPUT_DRIVERS", "CHANNELS",
  "INFO", "AUDIO_OUTPUT_DEVICE_COUNT", "AUDIO_OUTPUT_DEVICE_INFO",
  "MIDI_INPUT_DEVICE_COUNT", "MIDI_INPUT_DEVICE_INFO",
  "MIDI_INSTRUMENT_MAP_COUNT", "MIDI_INSTRUMENT_MAP_INFO",
  "MIDI_INSTRUMENT_COUNT", "MIDI_INSTRUMENT_INFO",
  "DB_INSTRUMENT_DIRECTORY_COUNT", "DB_INSTRUMENT_DIRECTORY_INFO",
  "DB_INSTRUMENT_COUNT", "DB_INSTRUMENT_INFO", "DB_INSTRUMENTS_JOB_INFO",
  "CHANNEL_COUNT", "CHANNEL_INFO", "FX_SEND_COUNT", "FX_SEND_INFO",
  "BUFFER_FILL", "STREAM_COUNT", "VOICE_COUNT", "TOTAL_VOICE_COUNT",
  "TOTAL_VOICE_COUNT_MAX", "GLOBAL_INFO", "INSTRUMENT", "ENGINE",
  "ON_DEMAND", "ON_DEMAND_HOLD", "PERSISTENT",
  "AUDIO_OUTPUT_DEVICE_PARAMETER", "AUDIO_OUTPUT_DEVICES",
  "AUDIO_OUTPUT_DEVICE", "AUDIO_OUTPUT_DRIVER_PARAMETER",
  "AUDIO_OUTPUT_DRIVER", "AUDIO_OUTPUT_CHANNEL_PARAMETER",
  "AUDIO_OUTPUT_CHANNEL", "AUDIO_OUTPUT_TYPE",
  "AVAILABLE_MIDI_INPUT_DRIVERS", "MIDI_INPUT_DEVICE_PARAMETER",
  "MIDI_INPUT_PORT_PARAMETER", "MIDI_INPUT_DEVICES", "MIDI_INPUT_DEVICE",
  "MIDI_INPUT_DRIVER_PARAMETER", "MIDI_INSTRUMENT", "MIDI_INSTRUMENTS",
  "MIDI_INSTRUMENT_MAP", "MIDI_INSTRUMENT_MAPS", "MIDI_INPUT_DRIVER",
  "MIDI_INPUT_PORT", "MIDI_INPUT_CHANNEL", "MIDI_INPUT_TYPE", "MIDI_INPUT",
  "MIDI_CONTROLLER", "FX_SEND", "FX_SENDS", "DB_INSTRUMENT_DIRECTORY",
  "DB_INSTRUMENT_DIRECTORIES", "DB_INSTRUMENTS", "DB_INSTRUMENT",
  "DB_INSTRUMENTS_JOB", "INSTRUMENTS_DB", "DESCRIPTION", "FORCE", "FLAT",
  "RECURSIVE", "NON_RECURSIVE", "SERVER", "VOLUME", "LEVEL", "MUTE",
  "SOLO", "BYTES", "PERCENTAGE", "EDIT", "FORMAT", "RESET",
  "MISCELLANEOUS", "NAME", "ECHO", "QUIT", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,    35,    61,    44,    46,    43,    45,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      97,    98,    99,   100,   101,   102,    65,    66,    67,    68,
      69,    70,    39,    34,    47,    92,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    33,    36,    37,    38,
      40,    41,    42,    58,    59,    60,    62,    63,    64,    91,
      93,    94,    95,   123,   124,   125,   126,    32,    10,    13
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   100,   101,   101,   102,   102,   102,   102,   103,   103,
     103,   103,   103,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     108,   108,   108,   108,   109,   110,   110,   110,   110,   110,
     110,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   113,
     113,   113,   113,   113,   113,   114,   115,   115,   116,   116,
     116,   116,   117,   117,   118,   118,   119,   119,   119,   120,
     120,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   122,   123,   124,   124,   125,
     125,   126,   126,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   128,   128,   129,
     130,   130,   130,   131,   132,   133,   134,   135,   135,   136,
     137,   138,   139,   140,   141,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   151,   152,   152,   152,
     152,   153,   153,   154,   154,   155,   155,   155,   156,   156,
     157,   157,   157,   158,   158,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   160,   160,   160,   160,   160,
     160,   160,   160,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   162,   162,   162,   162,   162,
     162,   162,   162,   162,   162,   163,   163,   164,   164,   164,
     165,   165,   166,   166,   167,   167,   167,   167,   168,   168,
     168,   168,   169,   169,   169,   169,   170,   170,   171,   171,
     171,   171,   172,   172,   172,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   174,   174,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   175,   175,   175,   176,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     3,     0,     1,     1,     1,     1,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     3,     9,     7,     7,     9,
       5,     7,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
      16,    18,    18,    20,     7,     3,     3,     3,     5,     3,
       3,     1,     1,     5,     7,     9,     1,     5,     7,     9,
       1,     1,     5,     5,     7,     9,     7,     9,     1,     5,
       7,     5,     5,     5,     3,     1,     1,     3,     3,     9,
       1,     5,     3,     7,     5,     3,     5,     5,     3,     5,
       5,     1,     7,     9,     7,     9,     9,     3,     7,     9,
      11,     9,     9,     7,     7,     7,     7,     3,     3,     5,
       3,     5,     3,     5,     7,     3,     3,     3,     7,     5,
       7,     5,     5,     5,     5,     5,     3,     3,     5,     3,
       3,     5,     7,     5,     9,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     1,     0,     2,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     1,     3,     5,     3,     5,     3,     5,     7,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     4,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     1,     2,     2,
       3,     3,     3,     3,     1,     1,     2,     2,     1,     1,
       2,     2,     1,     1,     2,     2,     1,     2,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     2,     3,     4,     3,
       4,     1,     1,     1,     3,     3,     3,     5,     5,     4,
       4,     4,     6,     7,     4,     4,     3,     4,     7,     9,
       6,     3,     9,    11,     7,    17,    30,     8,     4,    25,
      24,    23,    22,    25,    24,    21,    20,    29,    28,    19,
      18,    23,    13,    12,    13,    12,    11,    12,    11,    17,
      21,    11,    10,     6,     9,    14,    10,    29,    20,    19,
      29,    19,    30,    20,    17,    28,    27,    25,    18,    17,
      27,    15,    16,    19,    20,    17,    15,    18,    15,    10,
      15,     7,     8,    23,    25,    14,    13,    18,    14,    11,
       5,     4,     9,    13,     6,     6,     5,     4,     4,     5,
      10,     4,     6,     5,    13,     4,     4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     7,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     6,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,   452,   453,
       2,     0,   434,     9,   422,   418,   417,   415,   416,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   371,
     372,   373,   374,   375,   376,   345,   346,   347,   348,   349,
     350,   344,   343,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   407,   409,   410,   411,   412,   413,   414,
     419,   420,   421,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   451,   305,    11,    12,   336,   342,
      10,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     454,     0,     0,     0,     0,     0,     0,     0,   455,     0,
       0,   456,     0,     0,     0,     0,   471,     0,     0,     0,
       3,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   306,   263,   307,   308,   309,   310,   311,   312,   313,
     314,   408,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   337,     0,     0,     0,    13,    34,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,     0,   101,   106,   118,   125,   126,     0,   110,     0,
       0,     0,     0,     0,   102,     0,   111,     0,     0,     0,
       0,     0,   130,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   141,     0,    14,     0,    15,     0,     0,
      26,     0,     0,    27,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,    17,     0,     0,     0,
      18,     0,     0,     0,     0,     0,     0,     0,    19,   206,
     208,   205,   203,   207,   204,     0,   211,     0,     0,     0,
       0,    20,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    23,    44,    45,    46,    47,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    48,    52,
      53,    54,    51,    50,    49,    65,    66,    64,    24,    67,
      68,    69,    70,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    71,    75,    76,    77,    74,    73,    72,    88,
      89,    87,    30,     0,     0,    31,   196,    25,     0,     0,
     461,     0,     0,   551,   459,     0,   464,   465,   460,   557,
       0,     0,     0,     0,     0,   264,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   197,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   458,
       0,     0,     0,     0,   553,     0,   457,     0,     0,     0,
       0,     0,     0,    43,   242,     0,     0,    35,   241,     0,
       0,     0,     0,     0,     0,   257,   255,   256,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   266,   267,   268,   269,   270,   271,   272,
     273,   274,     0,   127,   230,   128,     0,     0,     0,     0,
     132,   236,     0,   135,     0,   138,     0,     0,     0,   124,
       0,     0,     0,     0,     0,     0,   166,   167,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,   162,     0,   176,   177,     0,     0,     0,
       0,     0,   209,   210,   212,   214,     0,   216,     0,     0,
     179,     0,   240,     0,   180,     0,   239,    95,    96,    97,
       0,    99,     0,   100,     0,     0,     0,     0,     0,     0,
     147,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   158,   234,     0,   263,   235,   157,   258,
     259,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   165,   462,     0,   552,   470,     0,
       0,     0,     0,     0,   332,     0,   333,     0,   329,   338,
     339,   444,   445,   328,     0,   317,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   198,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   556,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   463,     0,
       0,     0,     0,     0,   275,   276,   277,   278,   279,   280,
     281,   282,   441,   435,   436,   438,   437,   439,   440,   442,
     443,     0,   446,   331,   330,   322,   334,   335,   340,   341,
     323,   315,   318,   319,   316,     0,     0,     0,    40,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   119,     0,     0,     0,   201,   202,   121,
     122,   123,   112,     0,   107,     0,     0,     0,   113,     0,
       0,   466,   131,   103,     0,     0,   136,   134,   137,   139,
     140,     0,     0,     0,     0,   231,     0,     0,     0,   171,
       0,     0,   169,     0,     0,   172,   173,   174,   175,     0,
       0,     0,   159,     0,   161,   163,   233,   178,   238,     0,
       0,     0,     0,   213,   215,     0,     0,   237,     0,   219,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     260,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,     0,     0,     0,     0,     0,     0,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   449,   447,   541,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   503,     0,     0,   544,     0,   545,
     478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   547,   548,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     555,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   472,     0,
     474,     0,     0,   450,   448,     0,     0,     0,    41,    37,
      38,     0,     0,     0,   474,     0,   531,     0,     0,     0,
       0,   120,   108,     0,   116,     0,   104,     0,   114,   133,
       0,     0,    94,   232,     0,     0,     0,   251,   254,   253,
     170,   168,     0,     0,   531,     0,     0,   415,   416,     0,
       0,   199,   245,   250,   249,   248,   247,   164,   244,     0,
       0,     0,     0,     0,   217,     0,   540,     0,     0,     0,
       0,   181,   223,     0,   224,   183,   225,   185,     0,     0,
     192,   193,   194,   186,   226,   187,   227,   228,   188,   229,
       0,   189,   190,   191,   142,     0,   144,     0,   148,     0,
     546,     0,     0,     0,     0,     0,     0,   154,   153,   156,
     155,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   477,     0,   532,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   325,   324,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   473,     0,     0,     0,     0,
       0,    39,    36,     0,     0,     0,     0,     0,     0,   549,
       0,   109,   117,   115,   105,   129,     0,     0,     0,     0,
     252,     0,     0,     0,   200,   320,   327,   326,   321,   246,
       0,     0,     0,     0,   218,     0,     0,     0,     0,   182,
       0,     0,     0,   143,   358,   146,   145,     0,     0,     0,
     151,   152,   149,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   502,     0,     0,     0,     0,     0,   467,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     469,     0,   542,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   184,     0,     0,
     150,     0,     0,   496,     0,     0,     0,     0,     0,   501,
       0,     0,     0,     0,     0,   498,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   529,     0,     0,     0,     0,     0,
       0,   493,     0,     0,   495,     0,     0,     0,   497,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   536,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     468,     0,     0,   539,     0,   492,     0,   494,     0,     0,
     554,     0,     0,   535,     0,     0,     0,     0,     0,     0,
       0,     0,   535,     0,     0,     0,     0,     0,     0,   550,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   538,     0,     0,   543,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   526,
     521,     0,   521,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   522,     0,     0,    90,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   475,     0,     0,     0,   519,
     525,     0,     0,   499,     0,     0,     0,   519,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   526,   528,   530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   499,
       0,     0,     0,     0,     0,     0,     0,   537,     0,   518,
       0,     0,     0,     0,     0,     0,    91,    92,   243,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   490,     0,     0,     0,
       0,     0,   523,     0,   509,   511,     0,     0,     0,     0,
       0,   523,     0,     0,     0,     0,     0,   509,     0,     0,
       0,     0,     0,     0,   514,     0,     0,     0,   489,     0,
       0,     0,     0,     0,     0,     0,   513,   508,     0,     0,
       0,     0,     0,     0,   524,     0,     0,     0,    93,     0,
       0,     0,     0,     0,   527,     0,     0,     0,     0,     0,
       0,   486,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   500,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   485,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     513,     0,     0,     0,     0,     0,   482,     0,     0,   533,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   491,     0,   481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     480,     0,     0,   484,     0,     0,     0,     0,   534,     0,
     517,     0,     0,     0,     0,   479,     0,     0,   483,     0,
       0,     0,     0,     0,   504,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   520,     0,   506,     0,   516,     0,
       0,     0,     0,     0,   515,     0,     0,     0,   488,     0,
     510,     0,     0,   507,   487,   512,   476,     0,   505
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    15,    16,    17,    18,   236,   364,   388,   285,   287,
     334,   250,   342,   306,   417,   290,   293,   297,   300,   310,
     331,   680,   412,   415,   622,   992,   946,   318,   660,   664,
    1836,  1271,  1273,  1275,  1283,  1285,  1288,   603,   974,  1232,
     995,   713,   610,  1006,   997,   665,   661,   557,   553,  1837,
    1257,  1251,  1252,   979,  1237,   563,   718,  1253,   715,   155,
     912,  1091,   611,   558,   756,  1255,   554,  1355,   746,  1239,
    1256,   748,   158,   159,   750,   751,   752,   753,    60,    61,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,  1287,  1281,  1282,   564,    31,    32,    33,    34,
     237,   252,   253,   254,   579,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   255,   256,   386,   332,   257,
    1839,  1840,  1841,   344,   258,   259,   260,   261,   262,   263,
     683,   264,   346,   265,   266,   267,   268,   269,   270,   238,
     272,   273,   274,   687,   688,   689,   703,   275,   276,   239,
     278,   240,   280,   281,   416,   707,   672,   565,   566,   567,
     282,   283,   704,   691,   692,   947,   948,    35,    36,    37,
     387,   698,   353,    38
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1316
static const yytype_int16 yypact[] =
{
      93, -1316, -1316,    29,   311,    62,   119,   152,   131,   299,
      54,   147,   196,    78,   158,   249,   280,  2670, -1316,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   175, -1316,   284,
     294,   312,   377,   293,   328,   381,   379,   385,   410,   441,
     432,   433,   453,    31,   444,   468,   338, -1316, -1316, -1316,
   -1316,   412, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
     835,   835,   835,   835,   835,   835,   835,   835,   835, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316,  3333, -1316, -1316,
   -1316,   238,   339,   477,   477,   479,   509,   513,   513,   116,
     116,   177,   217,   247,   431,   508,   508,   515,   511,   515,
   -1316,   532,   506,   535,   538,   539,   569,   554, -1316,   555,
     574, -1316,   575,   559,   565,   580, -1316,   564,   591,   579,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316,   835, -1316,   835,   835,   835,   835,   835,   835,   835,
     835, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316,   587,   615,   605, -1316, -1316,   175,   175,
     175,   401,   608,   620,   606,   597,   613,   622,   609,   610,
   -1316,   175, -1316, -1316, -1316, -1316, -1316,   175, -1316,   175,
     175,   175,   175,   175, -1316,   175, -1316,   175,   175,   175,
     175,   175, -1316,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175, -1316,   618, -1316,   175, -1316,   175,   619,
   -1316,   175,   631, -1316,   175,   175,   633, -1316,   175,   175,
   -1316,   175,   175,   611,   629,   624, -1316,   175,   175,   175,
   -1316,   175,   175,   175,   413,   626,   630,   646, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316,   175, -1316,   175,   175,   175,
     651, -1316,   175,   175, -1316,   175,   175,   175,   175,   639,
     676,   667, -1316,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   656,   657,   671,   682,   658,   669,
     675,   668,   672,   674, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316,   175,   679, -1316, -1316, -1316,   175,   677,
   -1316,   670,   678, -1316, -1316,   697, -1316, -1316, -1316, -1316,
     702,   705,   698,   683,   700, -1316,   739,   693,   737,   439,
     473,   307,   738,   742,   743,   695,   734,   701,   770,   724,
     751,   760,    40,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   567,   764,   764,   764,   764,  1098,   764,
     192,   192,   764,   764,   764,   774,   762,  1098,   778,   567,
     716,   198,   198,   718,   473,   473,   473,   473,   782,   723,
     783,  3333,  3333,  1098,  1098,  1098,  1098,   787,   791,   726,
     800,   567,  1098,   192,   192,   784,   316,  3333,  1098,   567,
     456,   473,   801,   796,   806,    42,  1098,  1098,  1098,  1098,
     794,   141,   108,   108,  1065,  3427,   810,   807,   814,   765,
     766,   815,    41,   813,   817,   824,   826,   819,  1098, -1316,
     838,   825,   821,   841, -1316,   830, -1316,   831,   850,   843,
     863,  2765,  2765, -1316, -1316,   839,   839, -1316, -1316,   864,
     865,   877,   175,   175,   175, -1316, -1316, -1316,   870,   872,
     873,   887,   888,   879,   890,   881,   904,   883,   891,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   894, -1316, -1316, -1316,   175,   175,   175,   175,
   -1316, -1316,   175, -1316,   175, -1316,   175,   175,   175, -1316,
     899,   897,  1098,   175,   175,   906, -1316, -1316,   907,   902,
     175,   175,   175,   175,   911,   175,   175,   175,   175,   912,
     903,   915,  2860,  2860,   175, -1316, -1316,   175,   916,   913,
     910,   917, -1316, -1316, -1316, -1316,   175, -1316,   175,   914,
   -1316,   175, -1316,   175, -1316,   175,  3333, -1316, -1316, -1316,
     923, -1316,   175, -1316,   921,   924,   922,   919,    66,   926,
   -1316,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   935,   175,   930,
     941,   934,   175,   175,   175,   175,   943,   175,   175,   175,
     175,   835,   835, -1316, -1316,   745,    47, -1316, -1316, -1316,
    3333,   936,   950,   939,   945,   937,   957,   948,   959,   958,
     964,   965,   175,   946, -1316, -1316,   938, -1316, -1316,   956,
     968,   954,   955,   908, -1316,   809,  3050,  2081,  4273, -1316,
   -1316, -1316, -1316, -1316,  2176, -1316,  2271,  2385,   973,   970,
     987,   473,   473,   443,   975,   976,   977,   978,   983,  1002,
     953,  1003,  1005,  1015,  1028,  1098,   111,  1098,  1098,  3333,
    1098,  3333,  3333,  1098,  1098,  1098,  1098,  3333,  1098,  1020,
    1098,  3333,  1098,  1098,   473,   473,   473,   473,  1098,   972,
    1022,   175, -1316,  1098,   974,  1026,  1027,  3333,   473,  3333,
     473,  1042,   473,   473,   473,   473,  1023,  1041,   994,  3333,
    3333,  1098,  1098,  1043,  1046,  1061,  1000,   473,   473,  1047,
    1098,   473,  1098,  1048,   473,  1049, -1316,  1004,  1068,  1069,
    1050,  1062,  1098,  1098,  1098,  1098,  1098,  1098,  1098,  1098,
    1098,  1098,  1098,  1098,  3333,  1098,  3333,  1098,  1063,  1098,
    1075,  1055,  1089,  1098,  1098,  1098,  1098,  1071,   473,   473,
     473,   473,  1024,  1037,   835,  1076,  1094,  1085,  1086,  1100,
    1106,  1044,  1103,  1108,  1097,  1109,  1098,  1093, -1316,  1114,
    1095,  1113,  1099,  1107, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316,   720,   621,  4273, -1316, -1316, -1316,  3050, -1316, -1316,
   -1316, -1316, -1316,  3050, -1316,  1104,  1054,  1105,   175,   175,
     175,   175,  1056,  1123,  1124,  1110,  1126,  1116,  1119,  1115,
    1081,  1137,  1131, -1316,  1122,  1147,   175, -1316, -1316, -1316,
   -1316, -1316, -1316,  2860,  3333,   175,   175,   175, -1316,  2860,
     175, -1316, -1316,  3333,   175,   175, -1316, -1316, -1316, -1316,
   -1316,  1140,  1087,  1098,   175, -1316,  1142,  1139,  1096,   175,
    3521,   175,   175,   175,  1141, -1316, -1316, -1316, -1316,  1111,
    1149,  1158,   175,  3615,   175,   175, -1316, -1316, -1316,  1112,
    1167,  1155,  1161, -1316, -1316,  1150,   175, -1316,   175, -1316,
    1173, -1316,  1121,  1164,  1169,  1176,  1181,  1171,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
    3709,   175,  3803,   175,  1186,   175,  1179,  1188,  1182,   175,
     175,   175,   175,  1191,   175,   175,   175,   175,   835,   835,
     835,  1129,  1175,  1196,  1183,  1184,  1189,  1197,  1193,  1187,
    1144,  1146, -1316,  1190,  1209,  1203,  1201,  1194,  1202, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316,   720,   621, -1316,   115,  1199,  1098,   473,   473,   473,
    1200,  1220,  1208,  1204, -1316,  1221,  1211, -1316,  1206, -1316,
   -1316,  1210,  1205,  1098,  3333,  1098,  1098,  1098,  3333,  1098,
    1098,  1098,  1212,  1216,   175,  1098,  1217,  1214,  1218,  3333,
    1950,  3333,  3333,  1219,  1207,  1232,  1223,  3333,  3145,   439,
    1225,  1226,  1241,  1228,  1230,  1098,  1098,  1244,  1231,  1233,
    1234,  1185, -1316, -1316,  1098,  1098,  3333,  1098,   425,  1098,
     567,  3333,  1098,  1065,  3427,  3427,  3145,  3333,  3145,  3333,
   -1316,   439,  1235,  1239,  1192,  1098,  1098,  1098,  1098,  1236,
     439,   439,   439,   439,   835,   835,  1237,  1198,  1248,  1242,
    1253,  1215,  1249,  1252,  1222,  1243,  1267,  1254, -1316,  1279,
   -1316,  1261,  1262, -1316, -1316,  1265,  1281,  1264, -1316, -1316,
     175,   175,  1263,  1274,  1268,  1270,  1271,   188,  1276,  1288,
    1293, -1316,  2860,   175, -1316,   175,  2860,   175, -1316, -1316,
    1275,  1098, -1316, -1316,  1277,  1280,  3897, -1316, -1316,  2955,
     175,   175,  1282,  1272, -1316,  1283,  3991,   835,   835,  2860,
    2860,  1318, -1316, -1316, -1316, -1316,  3333, -1316, -1316,  1284,
    1268,  1271,   358,  1296, -1316,   175, -1316,  1286,   360,  1240,
    1295, -1316, -1316,   175, -1316, -1316,  3333, -1316,  1301,  1298,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,  3333,
     175, -1316, -1316, -1316,  1318,  4085,  1318,  4179, -1316,  1245,
   -1316,  1311,   175,   175,   175,   175,  1302, -1316, -1316, -1316,
   -1316,  1294,  1312,  1255,  1299,  1256,  1307,   380,  1326,  1325,
    1310,  1313,  1328,  1329,  1305,  1314,  1327,  1333,  1324,  1098,
     473,  1315,  1336, -1316,  1317, -1316,  1319,  1321,  1330,  1323,
    1342,  3333,  3333,  3333,  3333,  1098,  1332,   175,  1337,  1338,
    1950,  1339,  1341,  1343,  3145,  2480,  3333, -1316,  2575,  3145,
    1347,  1348,  1351,  1331,  1098,  1352,  1353,  1358,  1334,  1098,
    1345,  1344,  1098,  3145,  3239,  1360,  1361,  1098,  1098,  1065,
     439,  1346,  1357,  1335,   122,  1359,   171,  1349,  1364,  1362,
    1365,  1363,  1379,  1370,  1378, -1316,  1340,  1375,  1397,  1374,
    1376, -1316, -1316,  1381,  1355,  1386,  1380,  1383,  1403, -1316,
    1390,   175,  3333,  3333,   175, -1316,  1387,  3333,  1388,  1394,
   -1316,  1396,  1395,  1392,  1318, -1316,  3333, -1316, -1316, -1316,
    1398,  1400,  1404,  1406, -1316,  1399,  1407,  1389,   400, -1316,
    1426,  1423,   175,  1318,  1298,  1318, -1316,  1409,  1414,   175,
   -1316, -1316, -1316,  1411,  1416,  1421,  1419,  1424,  1422,  1425,
    1427,  1435,  1428,  1429,  1441,  1430,  1444,  1431,  1432,  1443,
    1433,  1434,  1437,  1449,  1436,   190,  1452,  1393,  1439,  1457,
    1442,  1440,   175,  1445,  1462,  1463,  1446,  1402,  1447,  1408,
    1448, -1316,  1451,  1410,  1450,  1453,  1455, -1316,   567,  1460,
    1461,  1098,  1468,  1464,  1470,  1465,  1481,  1483,  1466,  1486,
    1474,  1454,  1469,  1476,  1479,  1493,  1475,  1477,  1485,  1484,
   -1316,  1487, -1316,  1488,  1482,  1490,  1496,  1495,   107,  1494,
    1456,  1513,  1498,   473,  1499,  1500,  1501,  1502,  1516,  1503,
    1518,  1507,  1504,   173,  1497,  1505,  1509, -1316,  1510,  1511,
   -1316,  1512,  1508, -1316,  1517,  1515,  1519,  1520,  1521, -1316,
    1532,  1524,  1522,  1525,  1478, -1316,  1489,  1526,  1537,  1530,
    1491,  1540,  1535,  1544,  1531,   151,  1538,  1549,  1556,  1550,
    1555,   175,  1557,  1541,  1542,  1506,  1559,  1514,  1562,  1563,
    1523,  1564,  1551,  1546,  1527,  1548,  1552,  1560,  1558,  1528,
    1554, -1316,  1561,  1565, -1316,  1569,  1570,  1568, -1316,  1577,
    1578,    17,  1566,  1567,   480,  1573,  1574,  1575,    18,  1576,
    1579,  1581,  1583,  1585,  1591,  1587,  1098,  1588,    26,  1543,
    1604,  1586,  1605,  1589,  1595,   485,  1590,  1596,  1593,   104,
   -1316,  1597,  1606, -1316,  1619, -1316,    28, -1316,  1598,  1607,
   -1316,  1608,  1624, -1316,  1626,  1610,  1623,  1571,   163,  1612,
    1614,  1572,  1580,  1631,  1625,  1611,  1616,  1617,  1618, -1316,
    1620,   175,  1621,  1632,  1637,  1633,  1643,  1636,  1627,  1638,
    1647,  1640,  1630,  1592,  1644,  1639,  1628,  1594,  1646,  1650,
    1599,   276,  1651,  1641,  1635, -1316,  1654,  1601, -1316,  1662,
    1645,  1656,  1603,  1667,  1661,  1663,  1665,  1672,  1671,  1613,
      34,  1664, -1316,  1065,  1658,  1666,  1657,  1681,  1659,  1683,
      35,  1686,  1669,  1685,  1613,    57,  1688,  1668,  1673,  1689,
    1691,  1674,  1677,  1678,  1690,  1680,  1696,  1634,  1684,  1682,
    1692,  1687,  1693,  1694,  1695,  1698,  1697,  1699,  1700,  1702,
    1701,  1704, -1316,  1708,  1706,   175,  1709,  1703,  1705,  1713,
    1707,  1715,  1716,  1720,  1712,  1723,  1679,  1718,  1714,  1732,
    1717,  1727,  1722,  1719,  1721,  1736,  1740,   245,  1724,  1741,
    1710,  1729,  1746,  1745,  1726, -1316,  1733,  1750,  1749,  1734,
    1652,  1754,  1755,  1711,   340,  1753,  1756, -1316,  1757,  1734,
    1760,  1744,  1761,  1725,  1762,  1747,  1748, -1316, -1316, -1316,
    1765,  1763,  1751,  1766,  1758,  1728,  1764,  1752,  1771, -1316,
    1770,  1759,  1769,  1775,  1767,  1772,  1768, -1316,  1773, -1316,
    1777,  1776,  1779,  1774,  1782,  1780,   175, -1316, -1316, -1316,
   -1316, -1316,  1778,  1781,  1783,  1784,  1785,  1796,  1786,  1787,
    1797,  1798,  1802,  1742,  1788,  1805, -1316,   269,  1789,  1804,
    1791,  1792, -1316,  1799,  1790,  1793,  1800,  1794,  1795,  1820,
    1821,  1801,  1822,  1803,  1806,   439,  1807, -1316,  1790,  1801,
    1809,  1808,  1825,  1811, -1316,  1814,  1810,  1819, -1316,  1812,
    1815,  1817,  1823,  1818,  1813,  1824,  1816, -1316,  1826,  1827,
    1828,  1829,  1831,  1832, -1316,  1830,  1834,  1833, -1316,  1835,
    1816,  1837,  1839,  1845, -1316,   271,  1841,  1836,  1840,  1838,
    1842, -1316,   336,  1846,  1847,  1850,  1848,  1858,  1849,  1868,
    1869, -1316,  1871,  1860,  1856,  1878,  1880,  1866,  1865,  1867,
    1881,  1864,  1870,  1872, -1316,  1873,  1875,  1861,  1888,  1874,
    1843,  1876,    33,  1877,  1879,  1882,  1883,  1884,  1885,  1887,
   -1316,  1886,  1894,  1889,  1890,  1891, -1316,  1892,  1895, -1316,
    1896,  1901,  1905,  1899,  1900,  1908,  1909,  1915,  1897,  1919,
    1917,  1906,  1904, -1316,  1956, -1316,  1907,  2005,  2024,  2009,
    2006,  2001,  2007,  2008,  2012,  2011,  2026,  2018,  2013,  2015,
   -1316,   364,  2016, -1316,  2019,  2036,  2029,  2038, -1316,  2039,
   -1316,  2041,  2028,  2042,  2043, -1316,  2030,  2032, -1316,  2046,
    2031,  2063,  2034,  2035,  1987,  2159,  2255,  2322,  2320,  2340,
    2323,  2343,  2344,  2327, -1316,  2339, -1316,  2347, -1316,  2335,
    2336,  2349,  2334,  2337, -1316,  2338,  2466,  2558, -1316,  2655,
   -1316,  2749,  2342, -1316, -1316, -1316, -1316,  2356, -1316
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316, -1316, -1316, -1316,  -793, -1316, -1316, -1316, -1316,
   -1316,  -869, -1315, -1316,   428,   309, -1316,  -437,  -930, -1186,
     434, -1111,  -433, -1050, -1064,  -758,  -736,  -316,   638,   -23,
     478, -1051,   505,  -785,  1036,  1102,  -648,  -523,   102,   704,
    -878,  1991,     6,  -475,  2147, -1316, -1080,  1642,  -719,   -25,
     281,  -710,   232,  -519,  -709, -1316, -1316,   -17,  2326, -1316,
   -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
   -1316, -1316,  -402,  1992, -1316,  -425, -1316, -1316, -1316, -1316,
      38,  2627,  2722,  2816,   430,  2812,  2907,  2908,  3189,  3283,
    3284,  3377,  3378,  3471,  3472,  3565,  3566,  3659,  3660,  3753,
    3754,  3847,  -150,  -135,  -127,   353, -1316,  3848,  3581,  3946,
   -1316, -1316, -1316, -1316,  4040,  -140, -1316, -1316,  4038,   -94,
   -1316,  4134, -1316,  4132,  4136,  -122, -1316,   369,   258,  -118,
    4199, -1316,  3856, -1316, -1316, -1316, -1316,   296,  4201,   209,
     135,   229,   282, -1316, -1316,  3850, -1316, -1316,  -340,    59,
   -1316,  -152, -1316, -1316, -1316, -1316, -1316, -1316, -1316, -1316,
    4198,   -19, -1316, -1316
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -306
static const yytype_int16 yytable[] =
{
     160,   714,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   951,   352,   156,   982,   928,   406,   994,   917,   307,
     311,   662,   749,   749,  1092,   917,   913,   923,   923,   919,
     624,   407,   626,  1124,   271,  1347,  1208,   308,   312,   408,
    1238,   623,  1291,  -305,  1439,   336,   348,  1229,    39,  1258,
     644,   605,  1449,   647,   652,  1653,  1662,   355,   677,   654,
     727,  1974,   668,   194,  1653,   667,  1690,   627,   578,   195,
      50,   663,  1752,  1752,   678,  1765,  1674,  1969,   361,   728,
     679,   363,    43,   249,     1,  1008,  1265,     2,    51,   653,
    1307,  1308,  1309,  1310,   839,   734,  1766,   669,    54,  1654,
    1663,  1302,  1303,  1304,  1305,  1294,   840,  1296,  1673,     3,
    1691,     4,     5,     6,     7,   562,  1753,  1761,    55,     8,
     614,   616,  1684,  1586,     9,    10,  1575,   706,   944,    11,
      12,    13,   303,    14,  -305,  -305,  -305,   304,    44,  1685,
    1456,   697,  1576,  1686,   613,   615,   945,  1205,   305,  1415,
    1457,    47,  1206,   656,   658,   630,   632,   699,   635,   636,
     637,   638,   211,   213,   214,   215,   216,   217,   218,   219,
     220,  1619,   700,   701,   697,   801,  1550,   655,   657,  1227,
      45,    -4,    -4,  1700,   671,   673,    46,    52,  1620,  1459,
     251,    56,  1591,   314,   919,   315,   292,   913,   316,  1460,
    1701,   335,   343,   913,  1204,   413,  1524,   418,  1592,   317,
    1525,   439,   440,   441,   555,   556,    53,   749,   749,   918,
     555,   556,  1526,  1336,   452,   749,  1337,   749,   749,   561,
     453,   629,   454,   455,   456,   457,   458,   244,   459,    57,
     460,   461,   462,   463,   464,   330,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   233,   234,  1451,   476,
    1238,   477,   154,  1816,   479,   233,   296,   481,   482,  1401,
     235,   484,   485,  1817,   486,   487,   662,  1818,  1277,   235,
     491,   492,   493,  1290,   494,   495,   496,  1890,   157,  1938,
    1258,   294,   580,  1424,  1733,  1734,   328,  1891,   501,  1939,
     502,   503,   504,   180,  1735,   506,   507,   581,   508,   509,
     510,   511,  1443,  1445,   181,   582,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,    48,   559,   555,
     556,   184,   943,    49,   949,   950,  1240,  1241,   555,   556,
     560,   960,    40,   962,   561,    41,   662,   182,    42,   621,
     965,  1209,  1210,   690,  1945,   241,   185,   242,   243,   244,
     245,   277,   551,   552,  1946,   681,   298,   301,    58,    59,
     198,   246,   337,   350,  1834,  1835,   199,   247,   248,   232,
     249,   279,  2016,   684,   918,   295,   536,   685,   749,  1009,
     329,   538,  2017,  1361,   749,  1366,  1362,   183,  1325,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,   682,  1035,   291,   186,  1388,   187,   702,  1389,   325,
    1039,  1040,  1041,  1042,   188,   201,   593,   594,   595,   596,
     597,   598,   599,   600,   601,  1495,   929,   930,  1325,   299,
     302,   442,   443,  1062,  1278,   338,   351,   339,   189,   233,
     296,   340,   304,   497,   443,   309,   313,   190,  1279,   604,
     349,   551,   552,   341,   559,   555,   556,   191,   966,   967,
     968,   969,   249,   604,   192,   604,   629,   670,   555,   556,
     561,   193,   981,   196,   983,   197,   985,   986,   987,   988,
     645,   646,   705,   708,   710,   555,   556,   604,  1657,  1658,
      58,  1003,  1004,  1679,  1680,   604,  1292,  1293,  1011,   284,
     917,   289,   693,   694,   695,   696,   747,   754,   385,   409,
     717,   719,   286,   288,   354,   355,   356,   357,   292,   358,
     631,   633,   296,   233,   359,   761,   762,   763,  1411,   414,
     360,  1414,  1044,  1045,  1046,  1047,   361,   362,   419,   363,
     420,   421,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,  1671,   201,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   422,   423,   790,
     791,   792,   793,   602,  1402,   794,   425,   795,   424,   796,
     797,   798,  1755,   427,   426,   428,   802,   803,   429,   430,
     431,   749,   432,   807,   808,   809,   810,   433,   812,   813,
     814,   815,   662,   662,   436,   819,   820,   821,   604,   434,
     822,   894,   895,   896,   897,   898,   899,   900,   901,   827,
     714,   828,   437,   438,   830,   444,   831,   445,   832,   446,
     447,   448,   449,   450,   451,   834,   475,   478,   480,  1482,
     483,   488,   490,   498,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
    1221,   859,   489,   499,   500,   863,   864,   865,   866,   512,
     868,   869,   870,   871,   505,   211,   213,   214,   215,   216,
     217,   218,   219,   220,   513,   514,   526,   527,   528,   529,
     531,   530,  1264,   532,  1838,   886,   534,   533,   535,   540,
     749,  1280,   537,   542,   539,   541,   545,   547,   546,   914,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,   874,   543,   544,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   548,   550,   568,   569,   570,
     572,   575,   642,   643,   212,   212,   212,   212,   212,   212,
     212,   212,   212,  1211,   973,   549,   952,   571,   666,   955,
     956,   957,   958,   573,   604,  1838,   604,  1581,   964,   574,
     576,   577,   578,   620,   970,   621,   720,   625,   628,   975,
     634,   639,   641,   872,   873,   640,   648,   649,   650,   894,
     895,   896,   897,   898,   899,   900,   901,   996,   998,   651,
     674,   749,   659,   675,   902,   676,  1007,   697,   722,   721,
     723,   903,   904,   905,   906,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   662,   714,   724,   725,   726,
     729,  1031,   731,  1033,   330,   604,   730,   733,   735,   736,
     737,   738,   907,   755,   232,   232,   908,   739,   909,   740,
     910,   742,   911,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   741,   606,   607,   608,   609,   232,   612,
     914,   743,   617,   618,   619,   758,   914,   760,   764,   759,
     765,  1096,  1097,  1098,  1099,   435,   766,   435,   435,   435,
     435,   435,   435,   435,   435,   767,   768,   769,   770,  1113,
     772,  1434,   771,   773,   774,   789,  1114,   799,  1115,  1116,
    1117,   800,  1118,  1119,   804,   805,   806,  1120,  1121,   811,
     816,   817,   232,   818,   823,   826,   824,  1125,   825,   835,
     837,   858,  1129,   829,  1131,  1129,  1132,   833,   836,   838,
     841,   861,   862,   867,   875,  1137,  1050,  1137,  1139,   975,
     860,   876,   877,   878,   880,   879,   881,   882,   883,  1145,
     884,  1146,   888,   885,   889,   887,   890,   891,   892,   925,
     893,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,   926,  1167,   927,  1169,   933,  1171,   932,
     934,   935,  1175,  1176,  1177,  1178,   936,  1180,  1181,  1182,
    1183,  1048,   937,   939,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,  1049,   938,   940,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   941,   662,   942,
     666,   961,   953,   954,   971,   972,   976,   989,   959,   977,
     978,   990,   963,   711,   712,   201,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   984,   991,   999,   980,  1000,
     980,  1001,  1002,  1012,  1005,  1010,  1013,  1014,  1015,  1016,
     993,   993,  1007,  1017,  1036,  1034,  1037,  1231,   201,   593,
     594,   595,   596,   597,   598,   599,   600,   601,  1038,  1043,
    1051,  1223,  1224,  1225,  1052,   975,  1228,   998,  1053,  1054,
    1055,  1233,  1056,  1058,  1059,  1030,  1057,  1032,  1060,  1061,
    1063,  1064,  1065,  1066,  1254,  1068,  1094,  1067,  1100,  1101,
    1184,  1185,  1007,  1093,  1102,  1095,  1104,  1106,  1103,  1105,
    1272,  1274,  1107,  1272,   604,  1284,  1286,  1109,  1272,   717,
     719,   719,  1254,  1108,  1254,  1110,  1111,  1112,  1122,  1123,
    1126,   998,   998,   998,   998,   232,   232,  1127,  1128,  1133,
     714,   232,  1135,  1329,  1330,   232,  1136,  1141,  1142,  1143,
    1144,  1147,  1149,  1134,  1140,  1341,  1342,  1150,  1343,  1344,
    1345,  1152,   232,  1148,  1151,  1153,  1170,  1172,  1173,  1179,
    1174,  1186,  1187,  1129,  1129,   232,  1188,  1190,   716,  1194,
    1191,  1189,  1357,  1357,  1193,  1192,  1195,  1233,  1196,  1198,
    1197,  1199,  1200,  1201,  1212,  1202,  1207,  1213,  1364,  1214,
    1216,  1243,  1220,  1215,  1217,  1230,  1369,  1218,  1205,  1219,
    1234,  1244,   232,  1235,   232,  1206,  1245,  1260,  1242,  1259,
    1261,  1262,  1263,  1372,  1266,  1267,  1268,  1270,  1269,  1299,
    1300,  1311,  1315,  1306,  1301,  1377,  1378,  1379,  1380,  1313,
    1312,  1314,  1317,  1318,  1320,  1321,  1322,   212,   212,   212,
     212,   212,   212,   212,   212,   212,  1323,  1316,  1324,  1326,
    1325,  1327,  1328,  1331,  1319,  1332,  1333,  1334,  1339,  1335,
    1338,  1340,  1352,  1346,  1359,  1348,  1363,  1349,  1353,  1351,
    1417,  1370,  1367,  1368,  1360,  1007,  1365,  1375,  1427,  1376,
    1381,  1427,  1371,  1383,  1382,  1387,  1385,  1384,  1386,   872,
     873,  1233,  1390,  1391,  1392,  1396,  1398,  1393,  1394,  1395,
    1254,  1399,  1400,  1397,  1403,  1254,  1404,  1405,  1408,  1406,
    1407,  1409,  1410,  1455,  1433,  1274,  1440,  1438,  1284,  1254,
    1254,  1416,  1469,  1274,   996,   717,  1418,  1441,  1419,  1421,
    1422,  1453,  1461,  1423,  1137,  1222,  1430,  1137,  1431,  1226,
    1432,  1435,  1437,  1436,  1447,  1448,  1454,  1465,  1464,  1458,
    1236,  1463,   980,   980,  1462,   212,   212,  1466,  1246,   435,
    1467,  1468,  1470,  1471,  1472,  1498,  1474,  1473,  1476,  1477,
    1478,  1479,  1501,  1480,  1481,  1483,  1484,  1276,  1485,  1494,
    1486,  1487,  1289,  1488,  1492,   720,   720,  1475,  1295,  1489,
    1297,  1490,  1496,  1497,   232,  1491,  1493,  1500,   232,  1499,
    1502,  1503,  1504,  1505,  1507,  1533,  1510,  1506,   232,  1508,
    1509,  1513,  1515,  1518,  1516,  1520,  1512,  1511,   232,  1522,
    1514,  1517,  1527,  1519,  1521,  1528,  1523,  1530,   232,  1529,
    1532,  1531,  1535,  1536,  1538,  1534,  1537,  1539,  1541,  1544,
    1540,  1542,  1543,  1545,  1286,  1546,  1551,  1274,   232,  1548,
    1549,  1553,  1555,  1556,  1552,  1554,  1557,  1558,  1559,  1561,
    1562,   232,  1563,  1564,  1565,  1566,  1568,   232,  1567,   232,
    1356,  1356,  1571,  1572,  1573,  1569,  1577,  1570,  1574,  1579,
    1580,  1582,  1593,  1583,  1584,  1586,  1560,  1588,  1578,  1589,
    1595,  1585,  1587,  1590,  1594,  1596,  1598,  1599,  1597,  1601,
    1600,  1605,  1602,  1603,  1626,  1604,  1606,  1612,  1613,  1615,
    1609,  1616,  1607,  1617,  1608,  1611,   435,   435,   212,  1622,
    1618,  1610,  1621,  1614,  1623,  1625,  1624,  1627,   232,  1631,
    1628,  1629,  1633,  1634,  1636,  1637,  1638,  1640,  1630,  1648,
    1649,  1643,  1641,  1645,  1642,  1651,  1632,  1652,  1699,  1655,
    1646,  1659,  1660,  1661,  1647,  1635,  1650,  1665,  1656,  1639,
    1644,  1669,   993,  1412,  1413,   993,  1667,  1664,  1666,  1668,
    1670,  1672,  1007,  1674,  1676,  1654,  1426,  1675,  1678,  1426,
    1677,  1681,  1683,  1682,   232,   232,  1687,  1688,  1689,  1692,
    1693,  1695,  1694,  1698,  1713,  1696,  1702,  1703,   232,  1697,
    1706,  1715,  1708,  1707,  1704,  1709,  1710,  1716,  1711,  1712,
    1714,  1717,  1705,  1718,  1719,  1721,  1720,  1722,  1723,  1724,
    1731,  1726,  1728,  1727,  1725,  1738,  1729,  1730,  1741,  1736,
    1737,  1732,  1739,  1740,  1743,  1744,  1742,  1745,   666,  1746,
    1749,  1750,  1747,  1748,  1756,  1751,  1752,  1754,  1757,  1758,
    1759,  1760,  1762,  1764,  1767,  1768,  1772,  1765,  1769,   717,
    1763,  1770,  1773,  1775,  1776,  1771,  1777,  1778,  1774,  1779,
    1781,  1782,  1789,  1805,  1780,  1797,  1821,  1799,  1794,  1784,
    1786,  1796,  1803,  1787,  1830,  1783,  1785,  1788,  1790,  1791,
    1792,  1798,   212,   212,   435,  1793,  1795,  1800,  1802,  1801,
    1804,  1806,  1808,  1807,  1809,  1810,  1811,  1814,  1813,  1812,
    1815,  1820,  1822,  1819,  1823,  1824,  1825,  1827,  1826,  1828,
    1831,  1832,  1829,  1842,  1843,  1844,  1845,  1846,  1849,  1847,
    1853,  1851,  1850,  1852,  1854,  1859,  1855,  1860,  1861,  1863,
    1442,  1868,  1856,  1833,  1862,  1864,  1876,  1547,  1858,  1298,
    1874,  1877,  1450,  1878,  1865,  1880,  1872,  1848,  1867,  1875,
    1857,  1866,  1869,  1870,  1871,  1873,  1881,  1884,  1885,  1879,
    1883,  1882,  1886,  1889,  1887,  1893,  1894,  1888,  1897,  1892,
    1896,  1895,   716,  1900,  1901,  1899,  1902,  1903,  1905,  1904,
    1910,  1912,  1908,  1907,  1913,  1914,  1909,  1916,  1452,  1918,
    1919,  1917,  1921,  1932,  1429,   931,  1920,   716,  1923,  1943,
     716,  1925,   716,  1928,  1930,  1937,  1949,  1926,  1929,  1934,
    1941,  1933,  1935,  1931,  1940,  1898,  1936,  1951,   435,   435,
    1942,  1944,  1948,  1947,  1953,  1906,  1952,  1950,  1956,  1954,
    1911,  1955,  1915,  1957,  1958,  1922,  1959,  1960,  1924,  1961,
    1962,  1964,  1963,  1965,  1970,  1969,  1966,  1967,  1968,  1975,
    1927,  1971,  1974,  1973,  1977,  1982,  1987,  1989,  1976,  1980,
    1992,  1978,  1979,  1983,  1990,  1972,  1981,  1991,  1993,  1994,
    1985,  1995,  1986,  1988,  1984,  1997,  1996,  1998,  2000,  1999,
    2002,   212,   212,    62,   221,    64,    65,    66,    67,    68,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,   551,   552,   744,   745,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,  2001,  2003,
    2004,  2005,  2007,  2006,  2011,  2008,  2012,  2009,   716,  2010,
    2013,  2019,  2014,   716,  2015,  2018,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,   716,   716,  2035,
    2031,  2033,  2034,   716,    62,   221,    64,    65,    66,    67,
      68,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,   915,  2032,   916,   745,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,    62,
     221,    64,    65,    66,    67,    68,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,  2036,   920,
     916,   745,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,    62,   221,    64,    65,    66,    67,
      68,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,   921,  2037,   922,   745,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,  2038,
    2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2049,
    2048,  2050,  2052,  2057,  2051,  2058,  1420,   200,    62,   221,
      64,    65,    66,    67,    68,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   716,   924,   922,
     745,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    62,   221,    64,    65,    66,    67,    68,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,  1425,  2053,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    62,   221,
      64,    65,    66,    67,    68,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,  2054,  1428,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,  2055,   757,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    62,   221,
      64,    65,    66,    67,    68,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,  2056,   319,   744,
     745,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    62,   221,    64,    65,    66,    67,    68,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,  1358,   320,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    62,   221,
      64,    65,    66,    67,    68,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   321,   389,   916,
     745,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,    62,   221,    64,    65,    66,    67,    68,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,  1203,   390,   391,   745,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    62,   221,
      64,    65,    66,  1247,  1248,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,  1249,  1250,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    62,   221,    64,    65,    66,  1247,  1248,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,  1249,  1250,    91,    92,    93,    94,    95,    96,    97,
      98,    99,  1444,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    62,   221,    64,    65,
      66,    67,    68,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,   392,  1446,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      62,   221,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,   393,
     394,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    62,   221,  1130,    65,    66,    67,
      68,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,   395,   396,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    62,   221,
    1138,    65,    66,    67,    68,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   397,   398,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    62,   221,  1166,    65,    66,    67,    68,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,   399,   400,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    62,   221,  1168,    65,
      66,    67,    68,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,   401,   402,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      62,   221,  1350,    65,    66,    67,    68,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,   403,
     404,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    62,   221,  1354,    65,    66,    67,
      68,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,   405,   410,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    62,   221,
    1373,    65,    66,    67,    68,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   732,   333,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,    62,   221,  1374,    65,    66,    67,    68,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,   322,   345,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    62,   221,    64,    65,
      66,    67,    68,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,   323,   347,   324,   745,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     326,   686,   327,   709,   411
};

static const yytype_uint16 yycheck[] =
{
      17,   524,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,   779,   174,    17,   809,   761,   176,   820,   747,   169,
     170,   506,   551,   552,   912,   754,   746,   756,   757,   748,
     477,   176,   479,   973,   162,  1231,  1096,   169,   170,   176,
    1130,   476,  1163,     6,  1369,   173,   174,  1121,    29,  1139,
     493,   463,  1377,   496,   501,    48,    48,    27,    26,   502,
      29,    38,   509,    42,    48,   508,    48,   479,    38,    48,
      26,   506,    48,    48,    42,    28,    29,    54,    48,    48,
      48,    51,    30,    51,     1,   831,  1146,     4,    44,   501,
    1180,  1181,  1182,  1183,    38,   538,    49,   509,    30,    92,
      92,  1175,  1176,  1177,  1178,  1166,    50,  1168,    92,    26,
      92,    28,    29,    30,    31,   441,    92,    92,    50,    36,
     470,   471,    28,    29,    41,    42,    29,    29,    27,    46,
      47,    48,    26,    50,    97,    98,    99,    31,    29,    45,
      28,    43,    45,    49,   470,   471,    45,    42,    42,  1345,
      38,    30,    47,   503,   504,   481,   482,    26,   484,   485,
     486,   487,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    30,    41,    42,    43,   622,  1501,   503,   504,  1119,
      38,    98,    99,    30,   510,   511,    44,    50,    47,    28,
     162,    43,    29,    26,   913,    28,    29,   917,    31,    38,
      47,   173,   174,   923,  1092,   177,    26,   179,    45,    42,
      30,   238,   239,   240,    32,    33,    30,   746,   747,   748,
      32,    33,    42,    45,   251,   754,    48,   756,   757,    47,
     257,    43,   259,   260,   261,   262,   263,    30,   265,     0,
     267,   268,   269,   270,   271,    38,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,    28,    29,  1379,   286,
    1350,   288,    97,    28,   291,    28,    29,   294,   295,  1329,
      42,   298,   299,    38,   301,   302,   761,    42,  1157,    42,
     307,   308,   309,  1162,   311,   312,   313,    28,    17,    28,
    1380,   166,   452,  1354,    28,    29,   171,    38,   325,    38,
     327,   328,   329,    29,    38,   332,   333,   452,   335,   336,
     337,   338,  1373,  1374,    30,   452,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,    38,    31,    32,
      33,    48,   775,    44,   777,   778,  1131,  1132,    32,    33,
      43,   788,    41,   790,    47,    44,   831,    45,    47,    43,
     793,  1097,  1098,   515,    28,    26,    38,    28,    29,    30,
      31,   162,    32,    33,    38,   515,   167,   168,    98,    99,
      42,    42,   173,   174,    44,    45,    48,    48,    49,   157,
      51,   162,    28,   515,   913,   166,   413,   515,   917,   832,
     171,   418,    38,    45,   923,    45,    48,    30,    48,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   515,   859,   165,    43,    45,    47,   521,    48,   171,
     863,   864,   865,   866,    49,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    45,   762,   763,    48,   167,
     168,    50,    51,   886,    29,   173,   174,    26,    48,    28,
      29,    30,    31,    50,    51,   169,   170,    26,    43,   463,
     174,    32,    33,    42,    31,    32,    33,    45,   794,   795,
     796,   797,    51,   477,    51,   479,    43,    31,    32,    33,
      47,    38,   808,    49,   810,    27,   812,   813,   814,   815,
     494,   495,   521,   522,   523,    32,    33,   501,    28,    29,
      98,   827,   828,    28,    29,   509,  1164,  1165,   834,    42,
    1239,    42,   516,   517,   518,   519,   551,   552,   175,   176,
     524,   525,   163,   164,    26,    27,    28,    29,    29,    31,
     481,   482,    29,    28,    36,   562,   563,   564,  1341,    38,
      42,  1344,   868,   869,   870,   871,    48,    49,    26,    51,
      54,    26,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,  1626,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    49,    49,   606,
     607,   608,   609,    26,  1330,   612,    42,   614,    29,   616,
     617,   618,  1713,    29,    49,    30,   623,   624,    49,    44,
      30,  1130,    48,   630,   631,   632,   633,    26,   635,   636,
     637,   638,  1097,  1098,    37,   642,   643,   644,   622,    50,
     647,    10,    11,    12,    13,    14,    15,    16,    17,   656,
    1163,   658,    27,    38,   661,    37,   663,    27,   665,    43,
      53,    38,    30,    44,    44,   672,    38,    38,    27,  1417,
      27,    50,    38,    37,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
    1113,   698,    53,    53,    38,   702,   703,   704,   705,    50,
     707,   708,   709,   710,    43,   593,   594,   595,   596,   597,
     598,   599,   600,   601,    28,    38,    50,    50,    37,    27,
      41,    53,  1145,    38,  1794,   732,    44,    49,    44,    49,
    1239,  1158,    43,    26,    47,    47,    28,    27,    45,   746,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,     7,    51,    49,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    26,    29,    29,    26,    26,
      36,    47,   491,   492,    70,    71,    72,    73,    74,    75,
      76,    77,    78,  1099,   801,    92,   780,    92,   507,   783,
     784,   785,   786,    92,   788,  1875,   790,  1533,   792,    29,
      49,    41,    38,    29,   798,    43,   525,    29,    92,   803,
      92,    29,    29,   711,   712,    92,    29,    26,    92,    10,
      11,    12,    13,    14,    15,    16,    17,   821,   822,    29,
      29,  1350,    48,    37,    25,    29,   830,    43,    31,    29,
      26,    32,    33,    34,    35,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,  1330,  1379,    92,    92,    44,
      47,   855,    38,   857,    38,   859,    49,    48,    30,    44,
      49,    30,    63,    34,   642,   643,    67,    47,    69,    48,
      71,    38,    73,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,    43,   464,   465,   466,   467,   666,   469,
     917,    38,   472,   473,   474,    41,   923,    30,    38,    44,
      38,   928,   929,   930,   931,   211,    43,   213,   214,   215,
     216,   217,   218,   219,   220,    38,    38,    48,    38,   946,
      26,  1364,    51,    50,    43,    41,   953,    38,   955,   956,
     957,    44,   959,   960,    38,    38,    44,   964,   965,    38,
      38,    48,   720,    38,    38,    38,    43,   974,    48,    38,
      38,    26,   979,    49,   981,   982,   983,    44,    44,    50,
      44,    30,    38,    30,    38,   992,   874,   994,   995,   973,
      50,    31,    43,    38,    27,    48,    38,    28,    30,  1006,
      26,  1008,    54,    28,    38,    49,    28,    43,    43,    26,
      92,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,    43,  1031,    28,  1033,    41,  1035,    44,
      43,    43,  1039,  1040,  1041,  1042,    43,  1044,  1045,  1046,
    1047,     7,    30,    30,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,     7,    92,    41,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    42,  1533,    31,
     779,    41,   781,   782,    92,    43,    92,    44,   787,    43,
      43,    30,   791,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    43,    92,    44,   807,    43,
     809,    30,    92,    44,    47,    47,    92,    29,    29,    49,
     819,   820,  1096,    41,    29,    42,    51,  1124,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    29,    48,
      44,  1115,  1116,  1117,    30,  1119,  1120,  1121,    43,    43,
      30,  1125,    26,    30,    26,   854,    92,   856,    41,    30,
      47,    27,    47,    30,  1138,    38,    92,    48,    92,    26,
    1048,  1049,  1146,    49,    30,    50,    30,    38,    48,    43,
    1154,  1155,    47,  1157,  1158,  1159,  1160,    30,  1162,  1163,
    1164,  1165,  1166,    92,  1168,    44,    54,    30,    38,    92,
      38,  1175,  1176,  1177,  1178,   953,   954,    48,    92,    48,
    1713,   959,    43,  1210,  1211,   963,    38,    30,    43,    38,
      50,    28,    38,    92,    92,  1222,  1223,    38,  1225,  1226,
    1227,    30,   980,    92,    38,    44,    30,    38,    30,    28,
      38,    92,    47,  1240,  1241,   993,    30,    43,   524,    42,
      41,    48,  1249,  1250,    41,    38,    92,  1231,    92,    30,
      50,    38,    41,    49,    44,    43,    47,    27,  1265,    41,
      29,    44,    47,    49,    43,    43,  1273,    51,    42,    49,
      43,    29,  1030,    49,  1032,    47,    43,    41,    49,    44,
      29,    43,    42,  1290,    30,    44,    43,    92,    44,    44,
      41,    44,    29,    47,    92,  1302,  1303,  1304,  1305,    41,
      92,    49,    43,    41,    51,    28,    42,   593,   594,   595,
     596,   597,   598,   599,   600,   601,    27,    92,    47,    44,
      48,    30,    48,    50,    92,    41,    48,    47,    30,    48,
      44,    28,    50,    48,     6,    48,    30,    47,    45,    47,
    1347,    30,    92,    38,    50,  1329,    50,    92,  1355,    28,
      38,  1358,    44,    31,    50,    38,    47,    92,    92,  1247,
    1248,  1345,    26,    28,    44,    50,    29,    44,    30,    30,
    1354,    28,    38,    49,    49,  1359,    30,    50,    38,    50,
      49,    48,    30,    38,    43,  1369,    31,    43,  1372,  1373,
    1374,    49,    42,  1377,  1378,  1379,    49,    43,    50,    50,
      49,    45,    43,    50,  1411,  1114,    49,  1414,    50,  1118,
      49,    49,    44,    50,    44,    44,    49,    44,    43,    50,
    1129,    49,  1131,  1132,    50,   711,   712,    38,  1137,   715,
      50,    43,    47,    26,    50,  1442,    45,    51,    42,    49,
      47,    28,  1449,    43,    47,    47,    42,  1156,    42,    50,
      45,    49,  1161,    45,    45,  1164,  1165,    92,  1167,    49,
    1169,    47,    26,    30,  1222,    49,    49,    43,  1226,    50,
      49,    45,    41,    44,    42,  1482,    31,    43,  1236,    44,
      43,    30,    28,    30,    43,    41,    47,    49,  1246,    30,
      50,    49,    30,    50,    47,    92,    50,    30,  1256,    50,
      50,    49,    30,    30,    92,    50,    50,    50,    50,    49,
      92,    50,    92,    50,  1498,    50,    38,  1501,  1276,    49,
      49,    41,    31,    30,    50,    50,    50,    31,    44,    50,
      44,  1289,    43,    30,    49,    48,    42,  1295,    43,  1297,
    1249,  1250,    50,    43,    38,    48,    42,    49,    43,    26,
      42,    42,    45,    43,    43,    29,    92,    29,    92,    42,
      41,    49,    49,    49,    49,    45,    44,    49,    47,    44,
      43,    29,    43,    43,  1581,    44,    42,    30,    38,    29,
      92,    36,    50,    29,    49,    49,   872,   873,   874,    30,
      49,    92,    44,    92,    28,    30,    36,    30,  1356,    30,
      49,    49,    30,    30,    30,    44,    50,    49,    92,    30,
      30,    43,    50,    49,    44,    28,    92,    29,    37,    43,
      49,    38,    38,    38,    49,    92,    48,    38,    51,    92,
      92,    30,  1341,  1342,  1343,  1344,    43,    51,    47,    44,
      43,    43,  1626,    29,    29,    92,  1355,    51,    43,  1358,
      51,    51,    49,    47,  1412,  1413,    49,    41,    29,    51,
      43,    27,    44,    30,  1671,    29,    44,    43,  1426,    49,
      29,    29,    51,    38,    92,    49,    49,    30,    50,    49,
      49,    38,    92,    30,    38,    37,    49,    30,    38,    49,
      30,    37,    54,    44,    92,    50,    92,    41,    26,    38,
      49,    92,    38,    92,    38,    92,    51,    30,  1417,    38,
      28,    30,    39,    38,    38,    92,    48,    43,    51,    28,
      51,    28,    26,    28,    26,    47,    39,    28,    45,  1713,
      51,    30,    44,    43,    28,    51,    92,    43,    38,    47,
      43,    38,    30,    54,    42,    30,    26,    30,  1755,    44,
      43,    38,    30,    44,    92,    51,    48,    47,    47,    45,
      42,    38,  1048,  1049,  1050,    49,    47,    42,    38,    43,
      37,    43,    30,    49,    47,    38,    44,    31,    47,    50,
      30,    30,    43,    49,    28,    30,    50,    27,    45,    30,
      26,    26,    48,    30,    28,    28,    26,    43,    26,    28,
      27,    43,    45,    28,    43,    43,    30,    26,    28,    30,
    1372,    28,    44,    92,    45,    30,    28,  1498,    44,  1171,
      30,    30,  1378,    30,    47,    30,    42,    92,    50,  1836,
      92,    49,    45,    47,    45,    43,    30,    30,    30,    45,
      43,    45,    30,    28,    92,    31,    45,    49,    48,    50,
      41,    49,  1138,    49,    49,    45,    26,    26,    26,    48,
      41,    26,  1875,    47,    43,    41,    49,    38,  1380,    44,
      43,    49,    44,    29,  1359,   763,    43,  1163,    44,    31,
    1166,    45,  1168,    44,    42,    30,    26,    50,    47,    44,
      44,    48,    45,    53,    43,    92,    47,    29,  1184,  1185,
      50,    49,    45,    47,    26,    92,    47,    49,    38,    30,
      92,    30,    92,    47,    26,    92,    26,    41,    92,    44,
      43,    47,    31,    43,    26,    54,    44,    44,    43,    42,
      92,    47,    38,    47,    42,    31,    31,    26,    49,    42,
      30,    48,    47,    44,    29,    92,    50,    38,    30,    30,
      49,    26,    50,    47,    54,    26,    49,    30,    44,    43,
      43,  1247,  1248,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    92,    44,
      26,    42,    51,    47,    43,    48,    30,    49,  1354,    47,
      42,    42,    49,  1359,    49,    49,    30,    38,    30,    30,
      29,    43,    30,    30,    44,    43,    30,  1373,  1374,    92,
      49,    47,    47,  1379,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    51,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    49,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    49,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    47,
      50,    31,    49,    30,    30,    48,    37,    30,    43,    30,
      44,    47,    44,    41,    47,    29,  1350,    61,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,  1713,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    47,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    49,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    47,   556,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    48,   171,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,  1250,   171,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   171,   176,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,  1091,   176,   176,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,   176,  1374,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,   176,
     176,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   176,   176,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   176,   176,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   176,   176,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,   176,   176,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,   176,
     176,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   176,   176,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   536,   172,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   171,   174,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,   171,   174,   171,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
     171,   515,   171,   523,   176
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,     4,    26,    28,    29,    30,    31,    36,    41,
      42,    46,    47,    48,    50,   101,   102,   103,   104,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   196,   197,   198,   199,   277,   278,   279,   283,    29,
      41,    44,    47,    30,    29,    38,    44,    30,    38,    44,
      26,    44,    50,    30,    30,    50,    43,     0,    98,    99,
     178,   179,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,   159,   162,   170,   172,   173,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
      29,    30,    45,    30,    48,    38,    43,    47,    49,    48,
      26,    45,    51,    38,    42,    48,    49,    27,    42,    48,
     178,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,   158,   159,   158,   158,   158,   158,   158,   158,   158,
     158,     4,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,   172,    28,    29,    42,   105,   200,   249,   259,
     261,    26,    28,    29,    30,    31,    42,    48,    49,    51,
     111,   200,   201,   202,   203,   225,   226,   229,   234,   235,
     236,   237,   238,   239,   241,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   257,   258,   259,   260,   261,
     262,   263,   270,   271,    42,   108,   247,   109,   247,    42,
     115,   248,    29,   116,   260,   261,    29,   117,   259,   262,
     118,   259,   262,    26,    31,    42,   113,   235,   245,   257,
     119,   235,   245,   257,    26,    28,    31,    42,   127,   201,
     202,   203,   234,   241,   244,   248,   250,   258,   260,   261,
      38,   120,   228,   229,   110,   200,   249,   259,   262,    26,
      30,    42,   112,   200,   233,   238,   242,   243,   249,   257,
     259,   262,   271,   282,    26,    27,    28,    29,    31,    36,
      42,    48,    49,    51,   106,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   227,   280,   107,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     227,   280,   122,   200,    38,   123,   264,   114,   200,    26,
      54,    26,    49,    49,    29,    42,    49,    29,    30,    49,
      44,    30,    48,    26,    50,   159,    37,    27,    38,   177,
     177,   177,    50,    51,    37,    27,    43,    53,    38,    30,
      44,    44,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,    38,   177,   177,    38,   177,
      27,   177,   177,    27,   177,   177,   177,   177,    50,    53,
      38,   177,   177,   177,   177,   177,   177,    50,    37,    53,
      38,   177,   177,   177,   177,    43,   177,   177,   177,   177,
     177,   177,    50,    28,    38,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,    50,    50,    37,    27,
      53,    41,    38,    49,    44,    44,   177,    43,   177,    47,
      49,    47,    26,    51,    49,    28,    45,    27,    26,    92,
      29,    32,    33,   148,   166,    32,    33,   147,   163,    31,
      43,    47,   147,   155,   195,   267,   268,   269,    29,    26,
      26,    92,    36,    92,    29,    47,    49,    41,    38,   204,
     222,   223,   224,   204,   204,   204,   204,   204,   204,   204,
     204,   204,   204,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    26,   137,   162,   192,   204,   204,   204,   204,
     142,   162,   204,   147,   268,   147,   268,   204,   204,   204,
      29,    43,   124,   195,   137,    29,   137,   192,    92,    43,
     147,   269,   147,   269,    92,   147,   147,   147,   147,    29,
      92,    29,   170,   170,   142,   162,   162,   142,    29,    26,
      92,    29,   137,   192,   142,   147,   268,   147,   268,    48,
     128,   146,   163,   195,   129,   145,   170,   142,   137,   192,
      31,   147,   266,   147,    29,    37,    29,    26,    42,    48,
     121,   235,   239,   240,   245,   249,   252,   253,   254,   255,
     271,   273,   274,   162,   162,   162,   162,    43,   281,    26,
      41,    42,   239,   256,   272,   281,    29,   265,   281,   265,
     281,     8,     9,   141,   157,   158,   159,   162,   156,   162,
     170,    29,    31,    26,    92,    92,    44,    29,    48,    47,
      49,    38,   228,    48,   142,    30,    44,    49,    30,    47,
      48,    43,    38,    38,    34,    35,   168,   169,   171,   173,
     174,   175,   176,   177,   169,    34,   164,   164,    41,    44,
      30,   177,   177,   177,    38,    38,    43,    38,    38,    48,
      38,    51,    26,    50,    43,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,    41,
     177,   177,   177,   177,   177,   177,   177,   177,   177,    38,
      44,   137,   177,   177,    38,    38,    44,   177,   177,   177,
     177,    38,   177,   177,   177,   177,    38,    48,    38,   177,
     177,   177,   177,    38,    43,    48,    38,   177,   177,    49,
     177,   177,   177,    44,   177,    38,    44,    38,    50,    38,
      50,    44,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,    26,   177,
      50,    30,    38,   177,   177,   177,   177,    30,   177,   177,
     177,   177,   158,   158,     7,    38,    31,    43,    38,    48,
      27,    38,    28,    30,    26,    28,   177,    49,    54,    38,
      28,    43,    43,    92,    10,    11,    12,    13,    14,    15,
      16,    17,    25,    32,    33,    34,    35,    63,    67,    69,
      71,    73,   160,   171,   177,    32,    34,   168,   173,   174,
      33,    32,    34,   168,    33,    26,    43,    28,   146,   147,
     147,   155,    44,    41,    43,    43,    43,    30,    92,    30,
      41,    42,    31,   142,    27,    45,   126,   275,   276,   142,
     142,   145,   162,   170,   170,   162,   162,   162,   162,   170,
     137,    41,   137,   170,   162,   142,   147,   147,   147,   147,
     162,    92,    43,   177,   138,   162,    92,    43,    43,   153,
     170,   147,   153,   147,    43,   147,   147,   147,   147,    44,
      30,    92,   125,   170,   125,   140,   162,   144,   162,    44,
      43,    30,    92,   147,   147,    47,   143,   162,   146,   142,
      47,   147,    44,    92,    29,    29,    49,    41,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     170,   162,   170,   162,    42,   137,    29,    51,    29,   142,
     142,   142,   142,    48,   147,   147,   147,   147,     7,     7,
     158,    44,    30,    43,    43,    30,    26,    92,    30,    26,
      41,    30,   142,    47,    27,    47,    30,    48,    38,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   161,   160,    49,    92,    50,   177,   177,   177,   177,
      92,    26,    30,    48,    30,    43,    38,    47,    92,    30,
      44,    54,    30,   177,   177,   177,   177,   177,   177,   177,
     177,   177,    38,    92,   138,   177,    38,    48,    92,   177,
       5,   177,   177,    48,    92,    43,    38,   177,     5,   177,
      92,    30,    43,    38,    50,   177,   177,    28,    92,    38,
      38,    38,    30,    44,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,     5,   177,     5,   177,
      30,   177,    38,    30,    38,   177,   177,   177,   177,    28,
     177,   177,   177,   177,   158,   158,    92,    47,    30,    48,
      43,    41,    38,    41,    42,    92,    92,    50,    30,    38,
      41,    49,    43,   161,   160,    42,    47,    47,   143,   146,
     146,   147,    44,    27,    41,    49,    29,    43,    51,    49,
      47,   142,   170,   162,   162,   162,   170,   138,   162,   144,
      43,   177,   139,   162,    43,    49,   170,   154,   166,   169,
     153,   153,    49,    44,    29,    43,   170,     8,     9,    32,
      33,   151,   152,   157,   162,   165,   170,   150,   166,    44,
      41,    29,    43,    42,   142,   143,    30,    44,    43,    44,
      92,   131,   162,   132,   162,   133,   170,   131,    29,    43,
     137,   193,   194,   134,   162,   135,   162,   192,   136,   170,
     131,   141,   156,   156,   151,   170,   151,   170,   148,    44,
      41,    92,   144,   144,   144,   144,    47,   166,   166,   166,
     166,    44,    92,    41,    49,    29,    92,    43,    41,    92,
      51,    28,    42,    27,    47,    48,    44,    30,    48,   177,
     177,    50,    41,    48,    47,    48,    45,    48,    44,    30,
      28,   177,   177,   177,   177,   177,    48,   139,    48,    47,
       5,    47,    50,    45,     5,   167,   170,   177,   167,     6,
      50,    45,    48,    30,   177,    50,    45,    92,    38,   177,
      30,    44,   177,     5,     5,    92,    28,   177,   177,   177,
     177,    38,    50,    31,    92,    47,    92,    38,    45,    48,
      26,    28,    44,    44,    30,    30,    50,    49,    29,    28,
      38,   143,   146,    49,    30,    50,    50,    49,    38,    48,
      30,   125,   170,   170,   125,   139,    49,   177,    49,    50,
     154,    50,    49,    50,   151,    32,   170,   177,    33,   152,
      49,    50,    49,    43,   142,    49,    50,    44,    43,   132,
      31,    43,   134,   151,    43,   151,   193,    44,    44,   132,
     140,   141,   150,    45,    49,    38,    28,    38,    50,    28,
      38,    43,    50,    49,    43,    44,    38,    50,    43,    42,
      47,    26,    50,    51,    45,    92,    42,    49,    47,    28,
      43,    47,   145,    47,    42,    42,    45,    49,    45,    49,
      47,    49,    45,    49,    50,    45,    26,    30,   177,    50,
      43,   177,    49,    45,    41,    44,    43,    42,    44,    43,
      31,    49,    47,    30,    50,    28,    43,    49,    30,    50,
      41,    47,    30,    50,    26,    30,    42,    30,    92,    50,
      30,    49,    50,   177,    50,    30,    30,    50,    92,    50,
      92,    50,    50,    92,    49,    50,    50,   135,    49,    49,
     132,    38,    50,    41,    50,    31,    30,    50,    31,    44,
      92,    50,    44,    43,    30,    49,    48,    43,    42,    48,
      49,    50,    43,    38,    43,    29,    45,    42,    92,    26,
      42,   146,    42,    43,    43,    49,    29,    49,    29,    42,
      49,    29,    45,    45,    49,    41,    45,    47,    44,    49,
      43,    44,    43,    43,    44,    29,    42,    50,    49,    92,
      92,    49,    30,    38,    92,    29,    36,    29,    49,    30,
      47,    44,    30,    28,    36,    30,   177,    30,    49,    49,
      92,    30,    92,    30,    30,    92,    30,    44,    50,    92,
      49,    50,    44,    43,    92,    49,    49,    49,    30,    30,
      48,    28,    29,    48,    92,    43,    51,    28,    29,    38,
      38,    38,    48,    92,    51,    38,    47,    43,    44,    30,
      43,   143,    43,    92,    29,    51,    29,    51,    43,    28,
      29,    51,    47,    49,    28,    45,    49,    49,    41,    29,
      48,    92,    51,    43,    44,    27,    29,    49,    30,    37,
      30,    47,    44,    43,    92,    92,    29,    38,    51,    49,
      49,    50,    49,   177,    49,    29,    30,    38,    30,    38,
      49,    37,    30,    38,    49,    92,    37,    44,    54,    92,
      41,    30,    92,    28,    29,    38,    38,    49,    50,    38,
      92,    26,    51,    38,    92,    30,    38,    39,    38,    28,
      30,    92,    48,    92,    43,   141,    38,    51,    28,    51,
      28,    92,    26,    51,    28,    28,    49,    26,    47,    45,
      30,    51,    39,    44,    38,    43,    28,    92,    43,    47,
      42,    43,    38,    51,    44,    48,    43,    44,    47,    30,
      47,    45,    42,    49,   177,    47,    38,    30,    38,    30,
      42,    43,    38,    30,    37,    54,    43,    49,    30,    47,
      38,    44,    50,    47,    31,    30,    28,    38,    42,    49,
      30,    26,    43,    28,    30,    50,    45,    27,    30,    48,
      92,    26,    26,    92,    44,    45,   130,   149,   166,   230,
     231,   232,    30,    28,    28,    26,    43,    28,    92,    26,
      45,    43,    28,    27,    43,    30,    44,    92,    44,    43,
      26,    28,    45,    30,    30,    47,    49,    50,    28,    45,
      47,    45,    42,    43,    30,   177,    28,    30,    30,    45,
      30,    30,    45,    43,    30,    30,    30,    92,    49,    28,
      28,    38,    50,    31,    45,    49,    41,    48,    92,    45,
      49,    49,    26,    26,    48,    26,    92,    47,   149,    49,
      41,    92,    26,    43,    41,    92,    38,    49,    44,    43,
      43,    44,    92,    44,    92,    45,    50,    92,    44,    47,
      42,    53,    29,    48,    44,    45,    47,    30,    28,    38,
      43,    44,    50,    31,    49,    28,    38,    47,    45,    26,
      49,    29,    47,    26,    30,    30,    38,    47,    26,    26,
      41,    44,    43,    31,    47,    43,    44,    44,    43,    54,
      26,    47,    92,    47,    38,    42,    49,    42,    48,    47,
      42,    50,    31,    44,    54,    49,    50,    31,    47,    26,
      29,    38,    30,    30,    30,    26,    49,    26,    30,    43,
      44,    92,    43,    44,    26,    42,    47,    51,    48,    49,
      47,    43,    30,    42,    49,    49,    28,    38,    49,    42,
      30,    38,    30,    30,    29,    43,    30,    30,    44,    43,
      30,    49,    51,    47,    47,    92,    49,    49,    47,    50,
      31,    49,    30,    30,    48,    37,    30,    43,    44,    30,
      47,    47,    44,    47,    49,    47,    48,    41,    29
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 143 "lscp.y"
    { INCREMENT_LINE; return LSCP_DONE; }
    break;

  case 5:
#line 144 "lscp.y"
    { INCREMENT_LINE; return LSCP_DONE; }
    break;

  case 6:
#line 145 "lscp.y"
    { INCREMENT_LINE; LSCPSERVER->AnswerClient((yyvsp[(1) - (1)].String)); return LSCP_DONE; }
    break;

  case 7:
#line 146 "lscp.y"
    { INCREMENT_LINE; LSCPSERVER->AnswerClient("ERR:0:" + sLastError + "\r\n"); RESTART; return LSCP_SYNTAX_ERROR; }
    break;

  case 13:
#line 156 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 14:
#line 157 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 15:
#line 158 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 16:
#line 159 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 17:
#line 160 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 18:
#line 161 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 19:
#line 162 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 20:
#line 163 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 21:
#line 164 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 22:
#line 165 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 23:
#line 166 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 24:
#line 167 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 25:
#line 168 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 26:
#line 169 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 27:
#line 170 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 28:
#line 171 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 29:
#line 172 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 30:
#line 173 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 31:
#line 174 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                }
    break;

  case 32:
#line 175 "lscp.y"
    { (yyval.String) = LSCPSERVER->ResetSampler();                        }
    break;

  case 33:
#line 176 "lscp.y"
    { LSCPSERVER->AnswerClient("Bye!\r\n"); return LSCP_QUIT; }
    break;

  case 34:
#line 179 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddChannel();                  }
    break;

  case 35:
#line 180 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstrumentDirectory((yyvsp[(3) - (3)].String));  }
    break;

  case 36:
#line 181 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstruments((yyvsp[(5) - (9)].String),(yyvsp[(7) - (9)].String),(yyvsp[(9) - (9)].String), true);  }
    break;

  case 37:
#line 182 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstruments((yyvsp[(3) - (7)].String),(yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].String));        }
    break;

  case 38:
#line 183 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstruments((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].String), -1, true); }
    break;

  case 39:
#line 184 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstruments((yyvsp[(5) - (9)].String),(yyvsp[(7) - (9)].String),(yyvsp[(9) - (9)].Number), true);  }
    break;

  case 40:
#line 185 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstruments((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].String));           }
    break;

  case 41:
#line 186 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddDbInstruments((yyvsp[(3) - (7)].String),(yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].Number));        }
    break;

  case 42:
#line 187 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddMidiInstrumentMap();                }
    break;

  case 43:
#line 188 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddMidiInstrumentMap((yyvsp[(3) - (3)].String));              }
    break;

  case 44:
#line 191 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_audio_device_count);   }
    break;

  case 45:
#line 192 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_audio_device_info);    }
    break;

  case 46:
#line 193 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_midi_device_count);    }
    break;

  case 47:
#line 194 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_midi_device_info);     }
    break;

  case 48:
#line 195 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_channel_count);        }
    break;

  case 49:
#line 196 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_voice_count);          }
    break;

  case 50:
#line 197 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_stream_count);         }
    break;

  case 51:
#line 198 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_buffer_fill);          }
    break;

  case 52:
#line 199 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_channel_info);         }
    break;

  case 53:
#line 200 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_fx_send_count);        }
    break;

  case 54:
#line 201 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_fx_send_info);         }
    break;

  case 55:
#line 202 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_midi_instr_map_count); }
    break;

  case 56:
#line 203 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_midi_instr_map_info);  }
    break;

  case 57:
#line 204 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_midi_instr_count);     }
    break;

  case 58:
#line 205 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_midi_instr_info);      }
    break;

  case 59:
#line 206 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_db_instr_dir_count);   }
    break;

  case 60:
#line 207 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_db_instr_dir_info);    }
    break;

  case 61:
#line 208 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_db_instr_count);       }
    break;

  case 62:
#line 209 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_db_instr_info);        }
    break;

  case 63:
#line 210 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_db_instrs_job_info);   }
    break;

  case 64:
#line 211 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_misc);                 }
    break;

  case 65:
#line 212 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_total_voice_count);    }
    break;

  case 66:
#line 213 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_global_info);          }
    break;

  case 67:
#line 216 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_audio_device_count);   }
    break;

  case 68:
#line 217 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_audio_device_info);    }
    break;

  case 69:
#line 218 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_midi_device_count);    }
    break;

  case 70:
#line 219 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_midi_device_info);     }
    break;

  case 71:
#line 220 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_channel_count);        }
    break;

  case 72:
#line 221 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_voice_count);          }
    break;

  case 73:
#line 222 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_stream_count);         }
    break;

  case 74:
#line 223 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_buffer_fill);          }
    break;

  case 75:
#line 224 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_channel_info);         }
    break;

  case 76:
#line 225 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_fx_send_count);        }
    break;

  case 77:
#line 226 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_fx_send_info);         }
    break;

  case 78:
#line 227 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_midi_instr_map_count); }
    break;

  case 79:
#line 228 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_midi_instr_map_info);  }
    break;

  case 80:
#line 229 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_midi_instr_count);     }
    break;

  case 81:
#line 230 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_midi_instr_info);      }
    break;

  case 82:
#line 231 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_db_instr_dir_count);   }
    break;

  case 83:
#line 232 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_db_instr_dir_info);    }
    break;

  case 84:
#line 233 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_db_instr_count);       }
    break;

  case 85:
#line 234 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_db_instr_info);        }
    break;

  case 86:
#line 235 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_db_instrs_job_info);   }
    break;

  case 87:
#line 236 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_misc);                 }
    break;

  case 88:
#line 237 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_total_voice_count);    }
    break;

  case 89:
#line 238 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_global_info);          }
    break;

  case 90:
#line 241 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddOrReplaceMIDIInstrumentMapping((yyvsp[(4) - (16)].Number),(yyvsp[(6) - (16)].Number),(yyvsp[(8) - (16)].Number),(yyvsp[(10) - (16)].String),(yyvsp[(12) - (16)].String),(yyvsp[(14) - (16)].Number),(yyvsp[(16) - (16)].Dotnum),MidiInstrumentMapper::VOID,"",(yyvsp[(3) - (16)].Bool)); }
    break;

  case 91:
#line 242 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddOrReplaceMIDIInstrumentMapping((yyvsp[(4) - (18)].Number),(yyvsp[(6) - (18)].Number),(yyvsp[(8) - (18)].Number),(yyvsp[(10) - (18)].String),(yyvsp[(12) - (18)].String),(yyvsp[(14) - (18)].Number),(yyvsp[(16) - (18)].Dotnum),(yyvsp[(18) - (18)].LoadMode),"",(yyvsp[(3) - (18)].Bool)); }
    break;

  case 92:
#line 243 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddOrReplaceMIDIInstrumentMapping((yyvsp[(4) - (18)].Number),(yyvsp[(6) - (18)].Number),(yyvsp[(8) - (18)].Number),(yyvsp[(10) - (18)].String),(yyvsp[(12) - (18)].String),(yyvsp[(14) - (18)].Number),(yyvsp[(16) - (18)].Dotnum),MidiInstrumentMapper::VOID,(yyvsp[(18) - (18)].String),(yyvsp[(3) - (18)].Bool)); }
    break;

  case 93:
#line 244 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddOrReplaceMIDIInstrumentMapping((yyvsp[(4) - (20)].Number),(yyvsp[(6) - (20)].Number),(yyvsp[(8) - (20)].Number),(yyvsp[(10) - (20)].String),(yyvsp[(12) - (20)].String),(yyvsp[(14) - (20)].Number),(yyvsp[(16) - (20)].Dotnum),(yyvsp[(18) - (20)].LoadMode),(yyvsp[(20) - (20)].String),(yyvsp[(3) - (20)].Bool)); }
    break;

  case 94:
#line 247 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveMIDIInstrumentMapping((yyvsp[(3) - (7)].Number),(yyvsp[(5) - (7)].Number),(yyvsp[(7) - (7)].Number)); }
    break;

  case 95:
#line 250 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveChannel((yyvsp[(3) - (3)].Number));                      }
    break;

  case 96:
#line 251 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveMidiInstrumentMap((yyvsp[(3) - (3)].Number));            }
    break;

  case 97:
#line 252 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveAllMidiInstrumentMaps();          }
    break;

  case 98:
#line 253 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveDbInstrumentDirectory((yyvsp[(5) - (5)].String), true);  }
    break;

  case 99:
#line 254 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveDbInstrumentDirectory((yyvsp[(3) - (3)].String));        }
    break;

  case 100:
#line 255 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveDbInstrument((yyvsp[(3) - (3)].String));                 }
    break;

  case 101:
#line 258 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAvailableEngines();                          }
    break;

  case 102:
#line 259 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAvailableMidiInputDrivers();                 }
    break;

  case 103:
#line 260 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDriverInfo((yyvsp[(5) - (5)].String));                     }
    break;

  case 104:
#line 261 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDriverParameterInfo((yyvsp[(5) - (7)].String), (yyvsp[(7) - (7)].String));        }
    break;

  case 105:
#line 262 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDriverParameterInfo((yyvsp[(5) - (9)].String), (yyvsp[(7) - (9)].String), (yyvsp[(9) - (9)].KeyValList));    }
    break;

  case 106:
#line 263 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAvailableAudioOutputDrivers();               }
    break;

  case 107:
#line 264 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDriverInfo((yyvsp[(5) - (5)].String));                   }
    break;

  case 108:
#line 265 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDriverParameterInfo((yyvsp[(5) - (7)].String), (yyvsp[(7) - (7)].String));      }
    break;

  case 109:
#line 266 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDriverParameterInfo((yyvsp[(5) - (9)].String), (yyvsp[(7) - (9)].String), (yyvsp[(9) - (9)].KeyValList));  }
    break;

  case 110:
#line 267 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDeviceCount();                    }
    break;

  case 111:
#line 268 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDeviceCount();                      }
    break;

  case 112:
#line 269 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDeviceInfo((yyvsp[(5) - (5)].Number));                   }
    break;

  case 113:
#line 270 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDeviceInfo((yyvsp[(5) - (5)].Number));                     }
    break;

  case 114:
#line 271 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputPortInfo((yyvsp[(5) - (7)].Number), (yyvsp[(7) - (7)].Number));                   }
    break;

  case 115:
#line 272 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputPortParameterInfo((yyvsp[(5) - (9)].Number), (yyvsp[(7) - (9)].Number), (yyvsp[(9) - (9)].String));      }
    break;

  case 116:
#line 273 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputChannelInfo((yyvsp[(5) - (7)].Number), (yyvsp[(7) - (7)].Number));              }
    break;

  case 117:
#line 274 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputChannelParameterInfo((yyvsp[(5) - (9)].Number), (yyvsp[(7) - (9)].Number), (yyvsp[(9) - (9)].String)); }
    break;

  case 118:
#line 275 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetChannels();                                  }
    break;

  case 119:
#line 276 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetChannelInfo((yyvsp[(5) - (5)].Number));                             }
    break;

  case 120:
#line 277 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetBufferFill((yyvsp[(5) - (7)].FillResponse), (yyvsp[(7) - (7)].Number));                          }
    break;

  case 121:
#line 278 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetStreamCount((yyvsp[(5) - (5)].Number));                             }
    break;

  case 122:
#line 279 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetVoiceCount((yyvsp[(5) - (5)].Number));                              }
    break;

  case 123:
#line 280 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetEngineInfo((yyvsp[(5) - (5)].String));                              }
    break;

  case 124:
#line 281 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetServerInfo();                                }
    break;

  case 125:
#line 282 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetTotalVoiceCount();                           }
    break;

  case 126:
#line 283 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetTotalVoiceCountMax();                        }
    break;

  case 127:
#line 284 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInstrumentMappings((yyvsp[(3) - (3)].Number));                  }
    break;

  case 128:
#line 285 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAllMidiInstrumentMappings();                 }
    break;

  case 129:
#line 286 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInstrumentMapping((yyvsp[(5) - (9)].Number),(yyvsp[(7) - (9)].Number),(yyvsp[(9) - (9)].Number));             }
    break;

  case 130:
#line 287 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInstrumentMaps();                        }
    break;

  case 131:
#line 288 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInstrumentMap((yyvsp[(5) - (5)].Number));                       }
    break;

  case 132:
#line 289 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetFxSends((yyvsp[(3) - (3)].Number));                                 }
    break;

  case 133:
#line 290 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetFxSendInfo((yyvsp[(5) - (7)].Number),(yyvsp[(7) - (7)].Number));                           }
    break;

  case 134:
#line 291 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentDirectoryCount((yyvsp[(5) - (5)].String), true);        }
    break;

  case 135:
#line 292 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentDirectoryCount((yyvsp[(3) - (3)].String), false);       }
    break;

  case 136:
#line 293 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentDirectoryInfo((yyvsp[(5) - (5)].String));               }
    break;

  case 137:
#line 294 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentCount((yyvsp[(5) - (5)].String), true);                 }
    break;

  case 138:
#line 295 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentCount((yyvsp[(3) - (3)].String), false);                }
    break;

  case 139:
#line 296 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentInfo((yyvsp[(5) - (5)].String));                        }
    break;

  case 140:
#line 297 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentsJobInfo((yyvsp[(5) - (5)].Number));                    }
    break;

  case 141:
#line 298 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetGlobalVolume();                              }
    break;

  case 142:
#line 301 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputDeviceParameter((yyvsp[(3) - (7)].Number), (yyvsp[(5) - (7)].String), (yyvsp[(7) - (7)].String));      }
    break;

  case 143:
#line 302 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputChannelParameter((yyvsp[(3) - (9)].Number), (yyvsp[(5) - (9)].Number), (yyvsp[(7) - (9)].String), (yyvsp[(9) - (9)].String)); }
    break;

  case 144:
#line 303 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMidiInputDeviceParameter((yyvsp[(3) - (7)].Number), (yyvsp[(5) - (7)].String), (yyvsp[(7) - (7)].String));        }
    break;

  case 145:
#line 304 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMidiInputPortParameter((yyvsp[(3) - (9)].Number), (yyvsp[(5) - (9)].Number), (yyvsp[(7) - (9)].String), "");      }
    break;

  case 146:
#line 305 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMidiInputPortParameter((yyvsp[(3) - (9)].Number), (yyvsp[(5) - (9)].Number), (yyvsp[(7) - (9)].String), (yyvsp[(9) - (9)].String));      }
    break;

  case 147:
#line 306 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String);                                                         }
    break;

  case 148:
#line 307 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMidiInstrumentMapName((yyvsp[(5) - (7)].Number), (yyvsp[(7) - (7)].String));               }
    break;

  case 149:
#line 308 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetFxSendName((yyvsp[(5) - (9)].Number),(yyvsp[(7) - (9)].Number),(yyvsp[(9) - (9)].String));                        }
    break;

  case 150:
#line 309 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetFxSendAudioOutputChannel((yyvsp[(5) - (11)].Number),(yyvsp[(7) - (11)].Number),(yyvsp[(9) - (11)].Number),(yyvsp[(11) - (11)].Number)); }
    break;

  case 151:
#line 310 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetFxSendMidiController((yyvsp[(5) - (9)].Number),(yyvsp[(7) - (9)].Number),(yyvsp[(9) - (9)].Number));              }
    break;

  case 152:
#line 311 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetFxSendLevel((yyvsp[(5) - (9)].Number),(yyvsp[(7) - (9)].Number),(yyvsp[(9) - (9)].Dotnum));                       }
    break;

  case 153:
#line 312 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetDbInstrumentDirectoryName((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].String));            }
    break;

  case 154:
#line 313 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetDbInstrumentDirectoryDescription((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].String));     }
    break;

  case 155:
#line 314 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetDbInstrumentName((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].String));                     }
    break;

  case 156:
#line 315 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetDbInstrumentDescription((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].String));              }
    break;

  case 157:
#line 316 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetEcho((yyparse_param_t*) yyparse_param, (yyvsp[(3) - (3)].Dotnum));  }
    break;

  case 158:
#line 317 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetGlobalVolume((yyvsp[(3) - (3)].Dotnum));                            }
    break;

  case 159:
#line 320 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateAudioOutputDevice((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].KeyValList)); }
    break;

  case 160:
#line 321 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateAudioOutputDevice((yyvsp[(3) - (3)].String));    }
    break;

  case 161:
#line 322 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateMidiInputDevice((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].KeyValList));   }
    break;

  case 162:
#line 323 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateMidiInputDevice((yyvsp[(3) - (3)].String));      }
    break;

  case 163:
#line 324 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateFxSend((yyvsp[(3) - (5)].Number),(yyvsp[(5) - (5)].Number));            }
    break;

  case 164:
#line 325 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateFxSend((yyvsp[(3) - (7)].Number),(yyvsp[(5) - (7)].Number),(yyvsp[(7) - (7)].String)); }
    break;

  case 165:
#line 328 "lscp.y"
    { (yyval.String) = LSCPSERVER->ResetChannel((yyvsp[(3) - (3)].Number)); }
    break;

  case 166:
#line 331 "lscp.y"
    { (yyval.String) = LSCPSERVER->ClearMidiInstrumentMappings((yyvsp[(3) - (3)].Number));  }
    break;

  case 167:
#line 332 "lscp.y"
    { (yyval.String) = LSCPSERVER->ClearAllMidiInstrumentMappings(); }
    break;

  case 168:
#line 335 "lscp.y"
    { (yyval.String) = LSCPSERVER->FindDbInstruments((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].KeyValList), false);           }
    break;

  case 169:
#line 336 "lscp.y"
    { (yyval.String) = LSCPSERVER->FindDbInstruments((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].KeyValList), true);            }
    break;

  case 170:
#line 337 "lscp.y"
    { (yyval.String) = LSCPSERVER->FindDbInstrumentDirectories((yyvsp[(5) - (7)].String),(yyvsp[(7) - (7)].KeyValList), false); }
    break;

  case 171:
#line 338 "lscp.y"
    { (yyval.String) = LSCPSERVER->FindDbInstrumentDirectories((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].KeyValList), true);  }
    break;

  case 172:
#line 341 "lscp.y"
    { (yyval.String) = LSCPSERVER->MoveDbInstrumentDirectory((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].String)); }
    break;

  case 173:
#line 342 "lscp.y"
    { (yyval.String) = LSCPSERVER->MoveDbInstrument((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].String));          }
    break;

  case 174:
#line 345 "lscp.y"
    { (yyval.String) = LSCPSERVER->CopyDbInstrumentDirectory((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].String)); }
    break;

  case 175:
#line 346 "lscp.y"
    { (yyval.String) = LSCPSERVER->CopyDbInstrument((yyvsp[(3) - (5)].String),(yyvsp[(5) - (5)].String));          }
    break;

  case 176:
#line 349 "lscp.y"
    { (yyval.String) = LSCPSERVER->DestroyAudioOutputDevice((yyvsp[(3) - (3)].Number)); }
    break;

  case 177:
#line 350 "lscp.y"
    { (yyval.String) = LSCPSERVER->DestroyMidiInputDevice((yyvsp[(3) - (3)].Number));   }
    break;

  case 178:
#line 351 "lscp.y"
    { (yyval.String) = LSCPSERVER->DestroyFxSend((yyvsp[(3) - (5)].Number),(yyvsp[(5) - (5)].Number)); }
    break;

  case 179:
#line 354 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String); }
    break;

  case 180:
#line 355 "lscp.y"
    { (yyval.String) = (yyvsp[(3) - (3)].String); }
    break;

  case 181:
#line 358 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputDevice((yyvsp[(5) - (5)].Number), (yyvsp[(3) - (5)].Number));      }
    break;

  case 182:
#line 359 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputChannel((yyvsp[(5) - (7)].Number), (yyvsp[(7) - (7)].Number), (yyvsp[(3) - (7)].Number)); }
    break;

  case 183:
#line 360 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputType((yyvsp[(5) - (5)].String), (yyvsp[(3) - (5)].Number));        }
    break;

  case 184:
#line 361 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInput((yyvsp[(5) - (9)].Number), (yyvsp[(7) - (9)].Number), (yyvsp[(9) - (9)].Number), (yyvsp[(3) - (9)].Number));      }
    break;

  case 185:
#line 362 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputDevice((yyvsp[(5) - (5)].Number), (yyvsp[(3) - (5)].Number));        }
    break;

  case 186:
#line 363 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputPort((yyvsp[(5) - (5)].Number), (yyvsp[(3) - (5)].Number));          }
    break;

  case 187:
#line 364 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputChannel((yyvsp[(5) - (5)].Number), (yyvsp[(3) - (5)].Number));       }
    break;

  case 188:
#line 365 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputType((yyvsp[(5) - (5)].String), (yyvsp[(3) - (5)].Number));          }
    break;

  case 189:
#line 366 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetVolume((yyvsp[(5) - (5)].Dotnum), (yyvsp[(3) - (5)].Number));                 }
    break;

  case 190:
#line 367 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelMute((yyvsp[(5) - (5)].Dotnum), (yyvsp[(3) - (5)].Number));            }
    break;

  case 191:
#line 368 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelSolo((yyvsp[(5) - (5)].Dotnum), (yyvsp[(3) - (5)].Number));            }
    break;

  case 192:
#line 369 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelMap((yyvsp[(3) - (5)].Number), (yyvsp[(5) - (5)].Number));             }
    break;

  case 193:
#line 370 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelMap((yyvsp[(3) - (5)].Number), -1);             }
    break;

  case 194:
#line 371 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelMap((yyvsp[(3) - (5)].Number), -2);             }
    break;

  case 195:
#line 374 "lscp.y"
    { (yyval.String) = LSCPSERVER->EditSamplerChannelInstrument((yyvsp[(5) - (5)].Number)); }
    break;

  case 196:
#line 377 "lscp.y"
    { (yyval.String) = LSCPSERVER->FormatInstrumentsDb(); }
    break;

  case 197:
#line 380 "lscp.y"
    { (yyval.Bool) = true;  }
    break;

  case 198:
#line 381 "lscp.y"
    { (yyval.Bool) = false; }
    break;

  case 199:
#line 384 "lscp.y"
    { (yyval.KeyValList)[(yyvsp[(1) - (3)].String)] = (yyvsp[(3) - (3)].String);          }
    break;

  case 200:
#line 385 "lscp.y"
    { (yyval.KeyValList) = (yyvsp[(1) - (5)].KeyValList); (yyval.KeyValList)[(yyvsp[(3) - (5)].String)] = (yyvsp[(5) - (5)].String); }
    break;

  case 201:
#line 388 "lscp.y"
    { (yyval.FillResponse) = fill_response_bytes;      }
    break;

  case 202:
#line 389 "lscp.y"
    { (yyval.FillResponse) = fill_response_percentage; }
    break;

  case 203:
#line 392 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDevices();              }
    break;

  case 204:
#line 393 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDevices();                }
    break;

  case 205:
#line 394 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListChannels();                       }
    break;

  case 206:
#line 395 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAvailableEngines();               }
    break;

  case 207:
#line 396 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAvailableMidiInputDrivers();      }
    break;

  case 208:
#line 397 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAvailableAudioOutputDrivers();    }
    break;

  case 209:
#line 398 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListMidiInstrumentMappings((yyvsp[(3) - (3)].Number));       }
    break;

  case 210:
#line 399 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAllMidiInstrumentMappings();      }
    break;

  case 211:
#line 400 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListMidiInstrumentMaps();             }
    break;

  case 212:
#line 401 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListFxSends((yyvsp[(3) - (3)].Number));                      }
    break;

  case 213:
#line 402 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentDirectories((yyvsp[(5) - (5)].String), true); }
    break;

  case 214:
#line 403 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstrumentDirectories((yyvsp[(3) - (3)].String));       }
    break;

  case 215:
#line 404 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstruments((yyvsp[(5) - (5)].String), true);           }
    break;

  case 216:
#line 405 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetDbInstruments((yyvsp[(3) - (3)].String));                 }
    break;

  case 217:
#line 408 "lscp.y"
    { (yyval.String) = LSCPSERVER->LoadInstrument((yyvsp[(1) - (5)].String), (yyvsp[(3) - (5)].Number), (yyvsp[(5) - (5)].Number));       }
    break;

  case 218:
#line 409 "lscp.y"
    { (yyval.String) = LSCPSERVER->LoadInstrument((yyvsp[(3) - (7)].String), (yyvsp[(5) - (7)].Number), (yyvsp[(7) - (7)].Number), true); }
    break;

  case 219:
#line 412 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetEngineType((yyvsp[(1) - (3)].String), (yyvsp[(3) - (3)].Number)); }
    break;

  case 220:
#line 415 "lscp.y"
    { (yyval.LoadMode) = MidiInstrumentMapper::ON_DEMAND;      }
    break;

  case 221:
#line 416 "lscp.y"
    { (yyval.LoadMode) = MidiInstrumentMapper::ON_DEMAND_HOLD; }
    break;

  case 222:
#line 417 "lscp.y"
    { (yyval.LoadMode) = MidiInstrumentMapper::PERSISTENT;     }
    break;

  case 228:
#line 433 "lscp.y"
    { (yyval.Number) = 16; }
    break;

  case 235:
#line 452 "lscp.y"
    { (yyval.Dotnum) = (yyvsp[(1) - (1)].Number); }
    break;

  case 240:
#line 467 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (1)].UniversalPath).toPosix(); /*TODO: assuming POSIX*/ }
    break;

  case 241:
#line 470 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (1)].UniversalPath).toDbPath(); }
    break;

  case 246:
#line 483 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (3)].String) + "," + (yyvsp[(3) - (3)].String); }
    break;

  case 247:
#line 487 "lscp.y"
    { (yyval.String) = "\'" + (yyvsp[(1) - (1)].String) + "\'"; }
    break;

  case 248:
#line 488 "lscp.y"
    { (yyval.String) = "\'" + (yyvsp[(1) - (1)].String) + "\'"; }
    break;

  case 249:
#line 489 "lscp.y"
    { std::stringstream ss; ss << "\'" << (yyvsp[(1) - (1)].Number) << "\'"; (yyval.String) = ss.str(); }
    break;

  case 250:
#line 490 "lscp.y"
    { std::stringstream ss; ss << "\'" << (yyvsp[(1) - (1)].Dotnum) << "\'"; (yyval.String) = ss.str(); }
    break;

  case 251:
#line 493 "lscp.y"
    { (yyval.KeyValList)[(yyvsp[(1) - (3)].String)] = (yyvsp[(3) - (3)].String);          }
    break;

  case 252:
#line 494 "lscp.y"
    { (yyval.KeyValList) = (yyvsp[(1) - (5)].KeyValList); (yyval.KeyValList)[(yyvsp[(3) - (5)].String)] = (yyvsp[(5) - (5)].String); }
    break;

  case 255:
#line 501 "lscp.y"
    { (yyval.String) = "RECURSIVE"; }
    break;

  case 256:
#line 502 "lscp.y"
    { (yyval.String) = "NON_RECURSIVE"; }
    break;

  case 257:
#line 503 "lscp.y"
    { (yyval.String) = "FLAT"; }
    break;

  case 258:
#line 511 "lscp.y"
    { (yyval.Dotnum) = (yyvsp[(1) - (1)].Number); }
    break;

  case 259:
#line 512 "lscp.y"
    { (yyval.Dotnum) = -1; }
    break;

  case 260:
#line 515 "lscp.y"
    { std::stringstream ss((yyvsp[(1) - (3)].String) + "." + (yyvsp[(3) - (3)].String)); ss.imbue(std::locale::classic()); ss >> (yyval.Dotnum); }
    break;

  case 261:
#line 516 "lscp.y"
    { std::stringstream ss((yyvsp[(2) - (4)].String) + "." + (yyvsp[(4) - (4)].String)); ss.imbue(std::locale::classic()); ss >> (yyval.Dotnum); }
    break;

  case 262:
#line 517 "lscp.y"
    { std::stringstream ss("-" + (yyvsp[(2) - (4)].String) + "." + (yyvsp[(4) - (4)].String)); ss.imbue(std::locale::classic()); ss >> (yyval.Dotnum); }
    break;

  case 263:
#line 521 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (1)].Char);      }
    break;

  case 264:
#line 522 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].Char); }
    break;

  case 265:
#line 525 "lscp.y"
    { (yyval.Char) = '0'; }
    break;

  case 266:
#line 526 "lscp.y"
    { (yyval.Char) = '1'; }
    break;

  case 267:
#line 527 "lscp.y"
    { (yyval.Char) = '2'; }
    break;

  case 268:
#line 528 "lscp.y"
    { (yyval.Char) = '3'; }
    break;

  case 269:
#line 529 "lscp.y"
    { (yyval.Char) = '4'; }
    break;

  case 270:
#line 530 "lscp.y"
    { (yyval.Char) = '5'; }
    break;

  case 271:
#line 531 "lscp.y"
    { (yyval.Char) = '6'; }
    break;

  case 272:
#line 532 "lscp.y"
    { (yyval.Char) = '7'; }
    break;

  case 273:
#line 533 "lscp.y"
    { (yyval.Char) = '8'; }
    break;

  case 274:
#line 534 "lscp.y"
    { (yyval.Char) = '9'; }
    break;

  case 275:
#line 537 "lscp.y"
    { (yyval.Char) = '0'; }
    break;

  case 276:
#line 538 "lscp.y"
    { (yyval.Char) = '1'; }
    break;

  case 277:
#line 539 "lscp.y"
    { (yyval.Char) = '2'; }
    break;

  case 278:
#line 540 "lscp.y"
    { (yyval.Char) = '3'; }
    break;

  case 279:
#line 541 "lscp.y"
    { (yyval.Char) = '4'; }
    break;

  case 280:
#line 542 "lscp.y"
    { (yyval.Char) = '5'; }
    break;

  case 281:
#line 543 "lscp.y"
    { (yyval.Char) = '6'; }
    break;

  case 282:
#line 544 "lscp.y"
    { (yyval.Char) = '7'; }
    break;

  case 283:
#line 547 "lscp.y"
    { (yyval.Char) = '0'; }
    break;

  case 284:
#line 548 "lscp.y"
    { (yyval.Char) = '1'; }
    break;

  case 285:
#line 549 "lscp.y"
    { (yyval.Char) = '2'; }
    break;

  case 286:
#line 550 "lscp.y"
    { (yyval.Char) = '3'; }
    break;

  case 287:
#line 551 "lscp.y"
    { (yyval.Char) = '4'; }
    break;

  case 288:
#line 552 "lscp.y"
    { (yyval.Char) = '5'; }
    break;

  case 289:
#line 553 "lscp.y"
    { (yyval.Char) = '6'; }
    break;

  case 290:
#line 554 "lscp.y"
    { (yyval.Char) = '7'; }
    break;

  case 291:
#line 555 "lscp.y"
    { (yyval.Char) = '8'; }
    break;

  case 292:
#line 556 "lscp.y"
    { (yyval.Char) = '9'; }
    break;

  case 293:
#line 557 "lscp.y"
    { (yyval.Char) = 'a'; }
    break;

  case 294:
#line 558 "lscp.y"
    { (yyval.Char) = 'b'; }
    break;

  case 295:
#line 559 "lscp.y"
    { (yyval.Char) = 'c'; }
    break;

  case 296:
#line 560 "lscp.y"
    { (yyval.Char) = 'd'; }
    break;

  case 297:
#line 561 "lscp.y"
    { (yyval.Char) = 'e'; }
    break;

  case 298:
#line 562 "lscp.y"
    { (yyval.Char) = 'f'; }
    break;

  case 299:
#line 563 "lscp.y"
    { (yyval.Char) = 'a'; }
    break;

  case 300:
#line 564 "lscp.y"
    { (yyval.Char) = 'b'; }
    break;

  case 301:
#line 565 "lscp.y"
    { (yyval.Char) = 'c'; }
    break;

  case 302:
#line 566 "lscp.y"
    { (yyval.Char) = 'd'; }
    break;

  case 303:
#line 567 "lscp.y"
    { (yyval.Char) = 'e'; }
    break;

  case 304:
#line 568 "lscp.y"
    { (yyval.Char) = 'f'; }
    break;

  case 305:
#line 571 "lscp.y"
    { (yyval.Number) = atoi(String(1, (yyvsp[(1) - (1)].Char)).c_str());      }
    break;

  case 306:
#line 572 "lscp.y"
    { (yyval.Number) = atoi(String(String("1") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 307:
#line 573 "lscp.y"
    { (yyval.Number) = atoi(String(String("2") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 308:
#line 574 "lscp.y"
    { (yyval.Number) = atoi(String(String("3") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 309:
#line 575 "lscp.y"
    { (yyval.Number) = atoi(String(String("4") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 310:
#line 576 "lscp.y"
    { (yyval.Number) = atoi(String(String("5") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 311:
#line 577 "lscp.y"
    { (yyval.Number) = atoi(String(String("6") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 312:
#line 578 "lscp.y"
    { (yyval.Number) = atoi(String(String("7") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 313:
#line 579 "lscp.y"
    { (yyval.Number) = atoi(String(String("8") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 314:
#line 580 "lscp.y"
    { (yyval.Number) = atoi(String(String("9") + (yyvsp[(2) - (2)].String)).c_str()); }
    break;

  case 315:
#line 583 "lscp.y"
    { (yyval.UniversalPath) = (yyvsp[(2) - (3)].UniversalPath); }
    break;

  case 316:
#line 584 "lscp.y"
    { (yyval.UniversalPath) = (yyvsp[(2) - (3)].UniversalPath); }
    break;

  case 317:
#line 587 "lscp.y"
    { (yyval.UniversalPath) = Path();                           }
    break;

  case 318:
#line 588 "lscp.y"
    { (yyval.UniversalPath) = (yyvsp[(1) - (2)].UniversalPath);                               }
    break;

  case 319:
#line 589 "lscp.y"
    { Path p; p.appendNode((yyvsp[(2) - (2)].String)); (yyval.UniversalPath) = (yyvsp[(1) - (2)].UniversalPath) + p; }
    break;

  case 320:
#line 592 "lscp.y"
    { (yyval.String) = (yyvsp[(2) - (3)].String); }
    break;

  case 321:
#line 593 "lscp.y"
    { (yyval.String) = (yyvsp[(2) - (3)].String); }
    break;

  case 322:
#line 596 "lscp.y"
    { (yyval.String) = (yyvsp[(2) - (3)].String); }
    break;

  case 323:
#line 597 "lscp.y"
    { (yyval.String) = (yyvsp[(2) - (3)].String); }
    break;

  case 324:
#line 600 "lscp.y"
    { (yyval.String) = " ";      }
    break;

  case 326:
#line 602 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + " "; }
    break;

  case 327:
#line 603 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].String);  }
    break;

  case 328:
#line 607 "lscp.y"
    { (yyval.String) = " ";      }
    break;

  case 330:
#line 609 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + " "; }
    break;

  case 331:
#line 610 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].String);  }
    break;

  case 332:
#line 613 "lscp.y"
    { (yyval.String) = "/";      }
    break;

  case 334:
#line 615 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + "/"; }
    break;

  case 335:
#line 616 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].String);  }
    break;

  case 336:
#line 619 "lscp.y"
    { std::string s; s = (yyvsp[(1) - (1)].Char); (yyval.String) = s; }
    break;

  case 337:
#line 620 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].Char);                  }
    break;

  case 338:
#line 623 "lscp.y"
    { std::string s; s = (yyvsp[(1) - (1)].Char); (yyval.String) = s; }
    break;

  case 339:
#line 624 "lscp.y"
    { std::string s; s = (yyvsp[(1) - (1)].Char); (yyval.String) = s; }
    break;

  case 340:
#line 625 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].Char);                  }
    break;

  case 341:
#line 626 "lscp.y"
    { (yyval.String) = (yyvsp[(1) - (2)].String) + (yyvsp[(2) - (2)].Char);                  }
    break;

  case 343:
#line 631 "lscp.y"
    { (yyval.Char) = '\\'; }
    break;

  case 344:
#line 632 "lscp.y"
    { (yyval.Char) = '/';  }
    break;

  case 345:
#line 636 "lscp.y"
    { (yyval.Char) = 'A'; }
    break;

  case 346:
#line 636 "lscp.y"
    { (yyval.Char) = 'B'; }
    break;

  case 347:
#line 636 "lscp.y"
    { (yyval.Char) = 'C'; }
    break;

  case 348:
#line 636 "lscp.y"
    { (yyval.Char) = 'D'; }
    break;

  case 349:
#line 636 "lscp.y"
    { (yyval.Char) = 'E'; }
    break;

  case 350:
#line 636 "lscp.y"
    { (yyval.Char) = 'F'; }
    break;

  case 351:
#line 636 "lscp.y"
    { (yyval.Char) = 'G'; }
    break;

  case 352:
#line 636 "lscp.y"
    { (yyval.Char) = 'H'; }
    break;

  case 353:
#line 636 "lscp.y"
    { (yyval.Char) = 'I'; }
    break;

  case 354:
#line 636 "lscp.y"
    { (yyval.Char) = 'J'; }
    break;

  case 355:
#line 636 "lscp.y"
    { (yyval.Char) = 'K'; }
    break;

  case 356:
#line 636 "lscp.y"
    { (yyval.Char) = 'L'; }
    break;

  case 357:
#line 636 "lscp.y"
    { (yyval.Char) = 'M'; }
    break;

  case 358:
#line 636 "lscp.y"
    { (yyval.Char) = 'N'; }
    break;

  case 359:
#line 636 "lscp.y"
    { (yyval.Char) = 'O'; }
    break;

  case 360:
#line 636 "lscp.y"
    { (yyval.Char) = 'P'; }
    break;

  case 361:
#line 636 "lscp.y"
    { (yyval.Char) = 'Q'; }
    break;

  case 362:
#line 636 "lscp.y"
    { (yyval.Char) = 'R'; }
    break;

  case 363:
#line 636 "lscp.y"
    { (yyval.Char) = 'S'; }
    break;

  case 364:
#line 636 "lscp.y"
    { (yyval.Char) = 'T'; }
    break;

  case 365:
#line 636 "lscp.y"
    { (yyval.Char) = 'U'; }
    break;

  case 366:
#line 636 "lscp.y"
    { (yyval.Char) = 'V'; }
    break;

  case 367:
#line 636 "lscp.y"
    { (yyval.Char) = 'W'; }
    break;

  case 368:
#line 636 "lscp.y"
    { (yyval.Char) = 'X'; }
    break;

  case 369:
#line 636 "lscp.y"
    { (yyval.Char) = 'Y'; }
    break;

  case 370:
#line 636 "lscp.y"
    { (yyval.Char) = 'Z'; }
    break;

  case 371:
#line 637 "lscp.y"
    { (yyval.Char) = 'a'; }
    break;

  case 372:
#line 637 "lscp.y"
    { (yyval.Char) = 'b'; }
    break;

  case 373:
#line 637 "lscp.y"
    { (yyval.Char) = 'c'; }
    break;

  case 374:
#line 637 "lscp.y"
    { (yyval.Char) = 'd'; }
    break;

  case 375:
#line 637 "lscp.y"
    { (yyval.Char) = 'e'; }
    break;

  case 376:
#line 637 "lscp.y"
    { (yyval.Char) = 'f'; }
    break;

  case 377:
#line 637 "lscp.y"
    { (yyval.Char) = 'g'; }
    break;

  case 378:
#line 637 "lscp.y"
    { (yyval.Char) = 'h'; }
    break;

  case 379:
#line 637 "lscp.y"
    { (yyval.Char) = 'i'; }
    break;

  case 380:
#line 637 "lscp.y"
    { (yyval.Char) = 'j'; }
    break;

  case 381:
#line 637 "lscp.y"
    { (yyval.Char) = 'k'; }
    break;

  case 382:
#line 637 "lscp.y"
    { (yyval.Char) = 'l'; }
    break;

  case 383:
#line 637 "lscp.y"
    { (yyval.Char) = 'm'; }
    break;

  case 384:
#line 637 "lscp.y"
    { (yyval.Char) = 'n'; }
    break;

  case 385:
#line 637 "lscp.y"
    { (yyval.Char) = 'o'; }
    break;

  case 386:
#line 637 "lscp.y"
    { (yyval.Char) = 'p'; }
    break;

  case 387:
#line 637 "lscp.y"
    { (yyval.Char) = 'q'; }
    break;

  case 388:
#line 637 "lscp.y"
    { (yyval.Char) = 'r'; }
    break;

  case 389:
#line 637 "lscp.y"
    { (yyval.Char) = 's'; }
    break;

  case 390:
#line 637 "lscp.y"
    { (yyval.Char) = 't'; }
    break;

  case 391:
#line 637 "lscp.y"
    { (yyval.Char) = 'u'; }
    break;

  case 392:
#line 637 "lscp.y"
    { (yyval.Char) = 'v'; }
    break;

  case 393:
#line 637 "lscp.y"
    { (yyval.Char) = 'w'; }
    break;

  case 394:
#line 637 "lscp.y"
    { (yyval.Char) = 'x'; }
    break;

  case 395:
#line 637 "lscp.y"
    { (yyval.Char) = 'y'; }
    break;

  case 396:
#line 637 "lscp.y"
    { (yyval.Char) = 'z'; }
    break;

  case 397:
#line 638 "lscp.y"
    { (yyval.Char) = '0'; }
    break;

  case 398:
#line 638 "lscp.y"
    { (yyval.Char) = '1'; }
    break;

  case 399:
#line 638 "lscp.y"
    { (yyval.Char) = '2'; }
    break;

  case 400:
#line 638 "lscp.y"
    { (yyval.Char) = '3'; }
    break;

  case 401:
#line 638 "lscp.y"
    { (yyval.Char) = '4'; }
    break;

  case 402:
#line 638 "lscp.y"
    { (yyval.Char) = '5'; }
    break;

  case 403:
#line 638 "lscp.y"
    { (yyval.Char) = '6'; }
    break;

  case 404:
#line 638 "lscp.y"
    { (yyval.Char) = '7'; }
    break;

  case 405:
#line 638 "lscp.y"
    { (yyval.Char) = '8'; }
    break;

  case 406:
#line 638 "lscp.y"
    { (yyval.Char) = '9'; }
    break;

  case 407:
#line 639 "lscp.y"
    { (yyval.Char) = '!'; }
    break;

  case 408:
#line 639 "lscp.y"
    { (yyval.Char) = '#'; }
    break;

  case 409:
#line 639 "lscp.y"
    { (yyval.Char) = '$'; }
    break;

  case 410:
#line 639 "lscp.y"
    { (yyval.Char) = '%'; }
    break;

  case 411:
#line 639 "lscp.y"
    { (yyval.Char) = '&'; }
    break;

  case 412:
#line 639 "lscp.y"
    { (yyval.Char) = '('; }
    break;

  case 413:
#line 639 "lscp.y"
    { (yyval.Char) = ')'; }
    break;

  case 414:
#line 639 "lscp.y"
    { (yyval.Char) = '*'; }
    break;

  case 415:
#line 639 "lscp.y"
    { (yyval.Char) = '+'; }
    break;

  case 416:
#line 639 "lscp.y"
    { (yyval.Char) = '-'; }
    break;

  case 417:
#line 639 "lscp.y"
    { (yyval.Char) = '.'; }
    break;

  case 418:
#line 639 "lscp.y"
    { (yyval.Char) = ','; }
    break;

  case 419:
#line 640 "lscp.y"
    { (yyval.Char) = ':'; }
    break;

  case 420:
#line 640 "lscp.y"
    { (yyval.Char) = ';'; }
    break;

  case 421:
#line 640 "lscp.y"
    { (yyval.Char) = '<'; }
    break;

  case 422:
#line 640 "lscp.y"
    { (yyval.Char) = '='; }
    break;

  case 423:
#line 640 "lscp.y"
    { (yyval.Char) = '>'; }
    break;

  case 424:
#line 640 "lscp.y"
    { (yyval.Char) = '?'; }
    break;

  case 425:
#line 640 "lscp.y"
    { (yyval.Char) = '@'; }
    break;

  case 426:
#line 641 "lscp.y"
    { (yyval.Char) = '['; }
    break;

  case 427:
#line 641 "lscp.y"
    { (yyval.Char) = ']'; }
    break;

  case 428:
#line 641 "lscp.y"
    { (yyval.Char) = '^'; }
    break;

  case 429:
#line 641 "lscp.y"
    { (yyval.Char) = '_'; }
    break;

  case 430:
#line 642 "lscp.y"
    { (yyval.Char) = '{'; }
    break;

  case 431:
#line 642 "lscp.y"
    { (yyval.Char) = '|'; }
    break;

  case 432:
#line 642 "lscp.y"
    { (yyval.Char) = '}'; }
    break;

  case 433:
#line 642 "lscp.y"
    { (yyval.Char) = '~'; }
    break;

  case 435:
#line 646 "lscp.y"
    { (yyval.Char) = '\''; }
    break;

  case 436:
#line 647 "lscp.y"
    { (yyval.Char) = '\"'; }
    break;

  case 437:
#line 648 "lscp.y"
    { (yyval.Char) = '\\'; }
    break;

  case 438:
#line 649 "lscp.y"
    { (yyval.Char) = '/';  }
    break;

  case 439:
#line 650 "lscp.y"
    { (yyval.Char) = '\n'; }
    break;

  case 440:
#line 651 "lscp.y"
    { (yyval.Char) = '\r'; }
    break;

  case 441:
#line 652 "lscp.y"
    { (yyval.Char) = '\f'; }
    break;

  case 442:
#line 653 "lscp.y"
    { (yyval.Char) = '\t'; }
    break;

  case 443:
#line 654 "lscp.y"
    { (yyval.Char) = '\v'; }
    break;

  case 446:
#line 659 "lscp.y"
    { (yyval.Char) = (char) octalsToNumber((yyvsp[(2) - (2)].Char));       }
    break;

  case 447:
#line 660 "lscp.y"
    { (yyval.Char) = (char) octalsToNumber((yyvsp[(3) - (3)].Char),(yyvsp[(2) - (3)].Char));    }
    break;

  case 448:
#line 661 "lscp.y"
    { (yyval.Char) = (char) octalsToNumber((yyvsp[(4) - (4)].Char),(yyvsp[(3) - (4)].Char),(yyvsp[(2) - (4)].Char)); }
    break;

  case 449:
#line 664 "lscp.y"
    { (yyval.Char) = (char) hexsToNumber((yyvsp[(3) - (3)].Char));    }
    break;

  case 450:
#line 665 "lscp.y"
    { (yyval.Char) = (char) hexsToNumber((yyvsp[(4) - (4)].Char),(yyvsp[(3) - (4)].Char)); }
    break;


/* Line 1267 of yacc.c.  */
#line 5552 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 991 "lscp.y"


/**
 * Will be called when an error occured (usually syntax error).
 */
void yyerror(const char* s) {
    yyparse_param_t* param = GetCurrentYaccSession();
    String msg = s
        + (" (line:"   + ToString(param->iLine+1))
        + ( ",column:" + ToString(param->iColumn))
        + ")";
    dmsg(2,("LSCPParser: %s\n", msg.c_str()));
    sLastError = msg;
}

/**
 * Clears input buffer.
 */
void restart(yyparse_param_t* pparam, int& yychar) {
    bytes = 0;
    ptr   = 0;
    sLastError = "";
}

